import { XiomeConfig } from "../types/xiome-config-connected.js";
export declare function connect({ appId, apiOrigin, platformOrigin }: XiomeConfig): Promise<{
    appId: string;
    remote: import("renraku/x/types/remote/remote").Remote<{
        auth: {
            apps: {
                appService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").PlatformUserMeta, import("../../../features/auth/types/auth-metas.js").PlatformUserAuth, {
                    listApps({ appTables, statsHub }: import("../../../features/auth/types/auth-metas.js").PlatformUserAuth, { ownerUserId: ownerUserIdString }: {
                        ownerUserId: string;
                    }): Promise<import("../../../features/auth/aspects/apps/types/app-display.js").AppDisplay[]>;
                    registerApp({ appTables }: import("../../../features/auth/types/auth-metas.js").PlatformUserAuth, { appDraft, ownerUserId: ownerUserIdString }: {
                        appDraft: import("../../../features/auth/aspects/apps/types/app-draft.js").AppDraft;
                        ownerUserId: string;
                    }): Promise<import("../../../features/auth/aspects/apps/types/app-display.js").AppDisplay>;
                }, import("renraku/x/types/primitives/policy").Policy<import("../../../features/auth/types/auth-metas.js").PlatformUserMeta, import("../../../features/auth/types/auth-metas.js").PlatformUserAuth, import("renraku/x/types/http/http-request").HttpRequest>>;
                appEditService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").AppOwnerMeta, import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, {
                    updateApp({ appTables, authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString, appDraft }: {
                        appId: string;
                        appDraft: import("../../../features/auth/aspects/apps/types/app-draft.js").AppDraft;
                    }): Promise<void>;
                    deleteApp({ appTables, authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString }: {
                        appId: string;
                    }): Promise<void>;
                    listAdmins({ authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString }: {
                        appId: string;
                    }): Promise<import("../../../features/auth/aspects/apps/types/admin-email-display.js").AdminEmailDisplay[]>;
                    assignPlatformUserAsAdmin({ authTablesForPlatform, authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString, platformUserId: platformUserIdString }: {
                        appId: string;
                        platformUserId: string;
                    }): Promise<void>;
                    assignAdmin({ authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString, email }: {
                        appId: string;
                        email: string;
                    }): Promise<void>;
                    revokeAdmin({ authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString, userId: userIdString }: {
                        appId: string;
                        userId: string;
                    }): Promise<void>;
                }, import("renraku/x/types/primitives/policy").Policy<import("../../../features/auth/types/auth-metas.js").AppOwnerMeta, import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, import("renraku/x/types/http/http-request").HttpRequest>>;
            };
            users: {
                greenService: import("renraku/x/types/api/api-context").ApiContext<undefined, import("../../../features/auth/types/auth-metas.js").GreenAuth, {
                    authorize({ appTables, authTables: unconstrainedAuthTables }: import("../../../features/auth/types/auth-metas.js").GreenAuth, { scope, refreshToken, appId: appIdString, }: {
                        scope: import("../../../features/auth/types/auth-tokens.js").CoreScope;
                        appId: string;
                        refreshToken?: string;
                    }): Promise<string>;
                }, import("renraku/x/types/primitives/policy").Policy<undefined, import("../../../features/auth/types/auth-metas.js").GreenAuth, import("renraku/x/types/http/http-request").HttpRequest>>;
                loginService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").AnonMeta, import("../../../features/auth/types/auth-metas.js").LoginAuth, {
                    sendLoginLink({ access, authTables, appTables }: import("../../../features/auth/types/auth-metas.js").LoginAuth, inputs: {
                        email: string;
                    }): Promise<void>;
                    authenticateViaLoginToken({ access, authTables }: import("../../../features/auth/types/auth-metas.js").LoginAuth, { loginToken }: {
                        loginToken: string;
                    }): Promise<import("../../../toolbox/concurrent.js").AwaitProps<{
                        accessToken: Promise<string>;
                        refreshToken: Promise<string>;
                    }>>;
                }, import("renraku/x/types/primitives/policy").Policy<import("../../../features/auth/types/auth-metas.js").AnonMeta, import("../../../features/auth/types/auth-metas.js").LoginAuth, import("renraku/x/types/http/http-request").HttpRequest>>;
                userService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").AnonMeta, import("../../../features/auth/types/auth-metas.js").AnonAuth, {
                    getUser({ authTables, access }: import("../../../features/auth/types/auth-metas.js").AnonAuth, { userId }: {
                        userId: string;
                    }): Promise<{
                        userId: string;
                        profile: import("../../../features/auth/aspects/users/types/profile.js").Profile;
                        roles: import("../../../features/auth/aspects/users/types/public-user-role.js").PublicUserRole[];
                        stats: import("../../../features/auth/aspects/users/types/user-stats.js").UserStats;
                    }>;
                }, import("renraku/x/types/primitives/policy").Policy<import("../../../features/auth/types/auth-metas.js").AnonMeta, import("../../../features/auth/types/auth-metas.js").LoginAuth, import("renraku/x/types/http/http-request").HttpRequest>>;
                personalService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").AnonMeta, import("../../../features/auth/types/auth-metas.js").AnonAuth, {
                    setProfile({ access, authTables, checker }: import("../../../features/auth/types/auth-metas.js").AnonAuth, { userId: userIdString, profileDraft }: {
                        userId: string;
                        profileDraft: import("../../../features/auth/aspects/users/routines/personal/types/profile-draft.js").ProfileDraft;
                    }): Promise<void>;
                }, import("renraku/x/types/primitives/policy").Policy<import("../../../features/auth/types/auth-metas.js").UserMeta, import("../../../features/auth/types/auth-metas.js").UserAuth, import("renraku/x/types/http/http-request").HttpRequest>>;
            };
            permissions: {
                permissionsService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsMeta, import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, {
                    fetchPermissions({ engine }: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth): Promise<import("../../../features/auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                    createRole({ authTables }: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, { label }: {
                        label: string;
                    }): Promise<void>;
                    deleteRole({ authTables }: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, { roleId: roleIdString }: {
                        roleId: string;
                    }): Promise<void>;
                    assignPrivilege({ authTables }: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, { roleId: roleIdString, privilegeId: privilegeIdString }: {
                        roleId: string;
                        privilegeId: string;
                    }): Promise<void>;
                    unassignPrivilege({ authTables }: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, { roleId: roleIdString, privilegeId: privilegeIdString }: {
                        roleId: string;
                        privilegeId: string;
                    }): Promise<void>;
                    createPrivilege({ authTables }: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, { label }: {
                        label: string;
                    }): Promise<import("../../../features/auth/aspects/users/routines/permissions/types/privilege-display.js").PrivilegeDisplay>;
                    deletePrivilege({ engine, authTables }: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, { privilegeId: privilegeIdString }: {
                        privilegeId: string;
                    }): Promise<void>;
                }, (meta: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
                    engine: {
                        getUsersHaveRoles: ({ userIds, onlyGetPublicRoles }: {
                            userIds: string[];
                            onlyGetPublicRoles: boolean;
                        }) => Promise<{
                            userId: string;
                            userHasRoles: {
                                userId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                                roleId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                                timeframeStart: number;
                                timeframeEnd: number;
                                public: boolean;
                                hard: boolean;
                                time: number;
                            }[];
                        }[]>;
                        getAnonymousPrivileges: () => Promise<string[]>;
                        getPrivilegesForUsers: (userIds: string[]) => Promise<{
                            userId: string;
                            privileges: string[];
                        }[]>;
                        getPublicRolesForUsers: (userIds: string[]) => Promise<{
                            userId: string;
                            publicUserRoles: import("../../../features/auth/aspects/users/types/public-user-role.js").PublicUserRole[];
                        }[]>;
                        getPermissionsDisplay: () => Promise<import("../../../features/auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                        getPrivileges: (privilegeIds: string[]) => Promise<{
                            hard: boolean;
                            label: string;
                            time: number;
                            privilegeId: string;
                        }[]>;
                        getAllPrivileges: () => Promise<{
                            hard: boolean;
                            label: string;
                            time: number;
                            privilegeId: string;
                        }[]>;
                        getUserPrivileges: (userId: string) => Promise<string[]>;
                    };
                    access: import("../../../features/auth/types/auth-tokens.js").AccessPayload;
                    authTables: import("../../../features/auth/types/auth-tables.js").AuthTables;
                    checker: import("../../../features/auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
                        "manage store": string;
                        "give away freebies": string;
                        universal: string;
                        banned: string;
                        "view all videos": string;
                        "moderate videos": string;
                        "edit any profile": string;
                        "customize permissions": string;
                        "answer questions": string;
                        "moderate questions": string;
                        "view stats": string;
                        "administrate user roles": string;
                        "moderate livestream": string;
                        "read questions": string;
                        "post questions": string;
                        "like questions": string;
                        "report questions": string;
                        "view livestream": string;
                    }>;
                }>>;
            };
        };
        administrative: {
            roleAssignmentService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsMeta, import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, {
                fetchPermissions({ engine }: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth): Promise<import("../../../features/auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                searchUsers({ access, engine, authTables }: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, options: {
                    term: string;
                }): Promise<{
                    user: {
                        userId: string;
                        profile: import("../../../features/auth/aspects/users/types/profile.js").Profile;
                        roles: import("../../../features/auth/aspects/users/types/public-user-role.js").PublicUserRole[];
                        stats: import("../../../features/auth/aspects/users/types/user-stats.js").UserStats;
                    };
                    roleIds: string[];
                }[]>;
                assignRoleToUser({ authTables }: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, options: {
                    roleId: string;
                    userId: string;
                    isPublic: boolean;
                    timeframeEnd: number;
                    timeframeStart: number;
                }): Promise<void>;
                revokeRoleFromUser({ authTables }: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, options: {
                    roleId: string;
                    userId: string;
                }): Promise<void>;
            }, (meta: import("../../../features/auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
                engine: {
                    getUsersHaveRoles: ({ userIds, onlyGetPublicRoles }: {
                        userIds: string[];
                        onlyGetPublicRoles: boolean;
                    }) => Promise<{
                        userId: string;
                        userHasRoles: {
                            userId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                            roleId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                            timeframeStart: number;
                            timeframeEnd: number;
                            public: boolean;
                            hard: boolean;
                            time: number;
                        }[];
                    }[]>;
                    getAnonymousPrivileges: () => Promise<string[]>;
                    getPrivilegesForUsers: (userIds: string[]) => Promise<{
                        userId: string;
                        privileges: string[];
                    }[]>;
                    getPublicRolesForUsers: (userIds: string[]) => Promise<{
                        userId: string;
                        publicUserRoles: import("../../../features/auth/aspects/users/types/public-user-role.js").PublicUserRole[];
                    }[]>;
                    getPermissionsDisplay: () => Promise<import("../../../features/auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                    getPrivileges: (privilegeIds: string[]) => Promise<{
                        hard: boolean;
                        label: string;
                        time: number;
                        privilegeId: string;
                    }[]>;
                    getAllPrivileges: () => Promise<{
                        hard: boolean;
                        label: string;
                        time: number;
                        privilegeId: string;
                    }[]>;
                    getUserPrivileges: (userId: string) => Promise<string[]>;
                };
                access: import("../../../features/auth/types/auth-tokens.js").AccessPayload;
                authTables: import("../../../features/auth/types/auth-tables.js").AuthTables;
                checker: import("../../../features/auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
                    "manage store": string;
                    "give away freebies": string;
                    universal: string;
                    banned: string;
                    "view all videos": string;
                    "moderate videos": string;
                    "edit any profile": string;
                    "customize permissions": string;
                    "answer questions": string;
                    "moderate questions": string;
                    "view stats": string;
                    "administrate user roles": string;
                    "moderate livestream": string;
                    "read questions": string;
                    "post questions": string;
                    "like questions": string;
                    "report questions": string;
                    "view livestream": string;
                }>;
            }>>;
        };
        questions: {
            questionsReadingService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").AnonMeta, import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsAnonAuth, {
                fetchQuestions({ access, authTables, questionsTables }: import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsAnonAuth, { board }: {
                    board: string;
                }): Promise<{
                    users: {
                        userId: string;
                        profile: import("../../../features/auth/aspects/users/types/profile.js").Profile;
                        roles: import("../../../features/auth/aspects/users/types/public-user-role.js").PublicUserRole[];
                        stats: import("../../../features/auth/aspects/users/types/user-stats.js").UserStats;
                    }[];
                    questions: {
                        answers: import("../../../features/questions/api/types/questions-and-answers.js").Answer[];
                        questionId: string;
                        authorUserId: string;
                        board: string;
                        content: string;
                        archive: boolean;
                        timePosted: number;
                        liked: boolean;
                        likes: number;
                        reports: number;
                        reported: boolean;
                    }[];
                }>;
            }, (meta: import("../../../features/auth/types/auth-metas.js").AnonMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<import("../../../features/auth/types/auth-metas.js").LoginAuth & {
                questionsTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
                    "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
                }, import("../../../features/questions/api/tables/types/questions-tables.js").QuestionsTables>;
            }>>;
            questionsPostingService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").UserMeta, import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, {
                postQuestion({ access, questionsTables }: import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, inputs: {
                    questionDraft: import("../../../features/questions/api/types/question-draft.js").QuestionDraft;
                }): Promise<import("../../../features/questions/api/types/questions-and-answers.js").Question>;
                archiveQuestion({ access: { user: { userId } }, questionsTables, checker }: import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, inputs: {
                    archive: boolean;
                    questionId: string;
                }): Promise<void>;
                likeQuestion({ questionsTables, checker, access: { user: { userId: userIdString } } }: import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, inputs: {
                    like: boolean;
                    questionId: string;
                }): Promise<void>;
                reportQuestion({ questionsTables, checker, access: { user: { userId: userIdString } } }: import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, inputs: {
                    report: boolean;
                    questionId: string;
                }): Promise<void>;
            }, (meta: import("../../../features/auth/types/auth-metas.js").UserMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<import("../../../features/auth/types/auth-metas.js").UserAuth & {
                questionsTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
                    "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
                }, import("../../../features/questions/api/tables/types/questions-tables.js").QuestionsTables>;
            }>>;
            questionsAnsweringService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").UserMeta, import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, {
                postAnswer({ access, questionsTables }: import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, inputs: {
                    questionId: string;
                    answerDraft: import("../../../features/questions/api/types/answer-draft.js").AnswerDraft;
                }): Promise<import("../../../features/questions/api/types/questions-and-answers.js").Answer>;
                archiveAnswer({ access: { user: { userId } }, checker, questionsTables }: import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, inputs: {
                    archive: boolean;
                    answerId: string;
                }): Promise<void>;
                likeAnswer({ questionsTables, checker, access: { user: { userId: userIdString } } }: import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, inputs: {
                    like: boolean;
                    answerId: string;
                }): Promise<void>;
                reportAnswer({ questionsTables, checker, access: { user: { userId: userIdString } } }: import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, inputs: {
                    report: boolean;
                    answerId: string;
                }): Promise<void>;
            }, (meta: import("../../../features/auth/types/auth-metas.js").UserMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<import("../../../features/auth/types/auth-metas.js").UserAuth & {
                questionsTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
                    "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
                }, import("../../../features/questions/api/tables/types/questions-tables.js").QuestionsTables>;
            }>>;
            questionsModerationService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").UserMeta, import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, {
                archiveBoard({ questionsTables }: import("../../../features/questions/api/types/questions-metas-and-auths.js").QuestionsUserAuth, { board }: {
                    board: string;
                }): Promise<void>;
                fetchReportedQuestions(): Promise<void>;
            }, (meta: import("../../../features/auth/types/auth-metas.js").UserMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<import("../../../features/auth/types/auth-metas.js").UserAuth & {
                questionsTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
                    "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
                }, import("../../../features/questions/api/tables/types/questions-tables.js").QuestionsTables>;
            }>>;
        };
        example: {
            exampleService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").UserMeta, import("../../../features/example/api/types/example-metas-and-auth.js").ExampleUserAuth, {
                exampleFunction({ access, exampleTables }: import("../../../features/example/api/types/example-metas-and-auth.js").ExampleUserAuth, { something }: {
                    something: string;
                }): Promise<void>;
            }, (meta: import("../../../features/auth/types/auth-metas.js").UserMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
                exampleTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
                    "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
                }, import("../../../features/example/api/types/example-tables.js").ExampleTables>;
                access: import("../../../features/auth/types/auth-tokens.js").AccessPayload;
                authTables: import("../../../features/auth/types/auth-tables.js").AuthTables;
                checker: import("../../../features/auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
                    "manage store": string;
                    "give away freebies": string;
                    universal: string;
                    banned: string;
                    "view all videos": string;
                    "moderate videos": string;
                    "edit any profile": string;
                    "customize permissions": string;
                    "answer questions": string;
                    "moderate questions": string;
                    "view stats": string;
                    "administrate user roles": string;
                    "moderate livestream": string;
                    "read questions": string;
                    "post questions": string;
                    "like questions": string;
                    "report questions": string;
                    "view livestream": string;
                }>;
            }>>;
        };
        livestream: {
            livestreamViewingService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").UserMeta, import("../../../features/livestream/api/types/livestream-auths.js").LivestreamAuth, {
                getShows({ livestreamTables }: import("../../../features/livestream/api/types/livestream-auths.js").LivestreamAuth, inputs: {
                    labels: string[];
                }): Promise<import("../../../features/livestream/api/types/livestream-tables.js").LivestreamShow[]>;
            }, (meta: import("../../../features/auth/types/auth-metas.js").UserMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
                livestreamTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
                    "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
                }, import("../../../features/livestream/api/types/livestream-tables.js").LivestreamTables>;
                access: import("../../../features/auth/types/auth-tokens.js").AccessPayload;
                authTables: import("../../../features/auth/types/auth-tables.js").AuthTables;
                checker: import("../../../features/auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
                    "manage store": string;
                    "give away freebies": string;
                    universal: string;
                    banned: string;
                    "view all videos": string;
                    "moderate videos": string;
                    "edit any profile": string;
                    "customize permissions": string;
                    "answer questions": string;
                    "moderate questions": string;
                    "view stats": string;
                    "administrate user roles": string;
                    "moderate livestream": string;
                    "read questions": string;
                    "post questions": string;
                    "like questions": string;
                    "report questions": string;
                    "view livestream": string;
                }>;
            }>>;
            livestreamModerationService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").UserMeta, import("../../../features/livestream/api/types/livestream-auths.js").LivestreamAuth, {
                setShow({ livestreamTables }: import("../../../features/livestream/api/types/livestream-auths.js").LivestreamAuth, inputs: {
                    label: string;
                    vimeoId: string;
                }): Promise<void>;
            }, (meta: import("../../../features/auth/types/auth-metas.js").UserMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
                livestreamTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
                    "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
                }, import("../../../features/livestream/api/types/livestream-tables.js").LivestreamTables>;
                access: import("../../../features/auth/types/auth-tokens.js").AccessPayload;
                authTables: import("../../../features/auth/types/auth-tables.js").AuthTables;
                checker: import("../../../features/auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
                    "manage store": string;
                    "give away freebies": string;
                    universal: string;
                    banned: string;
                    "view all videos": string;
                    "moderate videos": string;
                    "edit any profile": string;
                    "customize permissions": string;
                    "answer questions": string;
                    "moderate questions": string;
                    "view stats": string;
                    "administrate user roles": string;
                    "moderate livestream": string;
                    "read questions": string;
                    "post questions": string;
                    "like questions": string;
                    "report questions": string;
                    "view livestream": string;
                }>;
            }>>;
        };
        videos: {
            dacastService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/videos/types/video-auth.js").VideoMeta, import("../../../features/videos/types/video-auth.js").VideoAuth, {
                getLink({ videoTables }: import("../../../features/videos/types/video-auth.js").VideoAuth): Promise<import("../../../features/videos/types/dacast-link.js").DacastLinkDisplay>;
                setLink({ videoTables }: import("../../../features/videos/types/video-auth.js").VideoAuth, inputs: {
                    apiKey: string;
                }): Promise<import("../../../features/videos/types/dacast-link.js").DacastLinkDisplay>;
                clearLink({ videoTables }: import("../../../features/videos/types/video-auth.js").VideoAuth): Promise<void>;
            }, (meta: import("../../../features/videos/types/video-auth.js").VideoMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
                checker: import("../../../features/auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
                    "view all videos": string;
                    "moderate videos": string;
                }>;
                engine: {
                    getUsersHaveRoles: ({ userIds, onlyGetPublicRoles }: {
                        userIds: string[];
                        onlyGetPublicRoles: boolean;
                    }) => Promise<{
                        userId: string;
                        userHasRoles: {
                            userId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                            roleId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                            timeframeStart: number;
                            timeframeEnd: number;
                            public: boolean;
                            hard: boolean;
                            time: number;
                        }[];
                    }[]>;
                    getAnonymousPrivileges: () => Promise<string[]>;
                    getPrivilegesForUsers: (userIds: string[]) => Promise<{
                        userId: string;
                        privileges: string[];
                    }[]>;
                    getPublicRolesForUsers: (userIds: string[]) => Promise<{
                        userId: string;
                        publicUserRoles: import("../../../features/auth/aspects/users/types/public-user-role.js").PublicUserRole[];
                    }[]>;
                    getPermissionsDisplay: () => Promise<import("../../../features/auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                    getPrivileges: (privilegeIds: string[]) => Promise<{
                        hard: boolean;
                        label: string;
                        time: number;
                        privilegeId: string;
                    }[]>;
                    getAllPrivileges: () => Promise<{
                        hard: boolean;
                        label: string;
                        time: number;
                        privilegeId: string;
                    }[]>;
                    getUserPrivileges: (userId: string) => Promise<string[]>;
                };
                videoTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
                    "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
                }, import("../../../features/videos/types/video-tables.js").VideoTables>;
                access: import("../../../features/auth/types/auth-tokens.js").AccessPayload;
                authTables: import("../../../features/auth/types/auth-tables.js").AuthTables;
            }>>;
            contentService: import("renraku/x/types/api/api-context").ApiContext<import("../../../features/videos/types/video-auth.js").VideoMeta, import("../../../features/videos/types/video-auth.js").VideoAuth, {
                fetchModerationData({ access, authTables, videoTables, checker, }: import("../../../features/videos/types/video-auth.js").VideoAuth): Promise<import("../../../features/videos/types/video-concepts.js").VideoModerationData>;
                writeView({ videoTables, checker, engine }: import("../../../features/videos/types/video-auth.js").VideoAuth, { label, privileges, reference, }: {
                    label: string;
                    privileges: string[];
                    reference: import("../../../features/videos/types/video-concepts.js").VideoHosting.DacastReference;
                }): Promise<void>;
                deleteView({ videoTables, checker }: import("../../../features/videos/types/video-auth.js").VideoAuth, { label }: {
                    label: string;
                }): Promise<void>;
                getShows({ videoTables, access, checker }: import("../../../features/videos/types/video-auth.js").VideoAuth, { labels }: {
                    labels: string[];
                }): Promise<import("../../../features/videos/types/video-concepts.js").VideoShow[]>;
            }, (meta: import("../../../features/videos/types/video-auth.js").VideoMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
                engine: {
                    getUsersHaveRoles: ({ userIds, onlyGetPublicRoles }: {
                        userIds: string[];
                        onlyGetPublicRoles: boolean;
                    }) => Promise<{
                        userId: string;
                        userHasRoles: {
                            userId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                            roleId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                            timeframeStart: number;
                            timeframeEnd: number;
                            public: boolean;
                            hard: boolean;
                            time: number;
                        }[];
                    }[]>;
                    getAnonymousPrivileges: () => Promise<string[]>;
                    getPrivilegesForUsers: (userIds: string[]) => Promise<{
                        userId: string;
                        privileges: string[];
                    }[]>;
                    getPublicRolesForUsers: (userIds: string[]) => Promise<{
                        userId: string;
                        publicUserRoles: import("../../../features/auth/aspects/users/types/public-user-role.js").PublicUserRole[];
                    }[]>;
                    getPermissionsDisplay: () => Promise<import("../../../features/auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                    getPrivileges: (privilegeIds: string[]) => Promise<{
                        hard: boolean;
                        label: string;
                        time: number;
                        privilegeId: string;
                    }[]>;
                    getAllPrivileges: () => Promise<{
                        hard: boolean;
                        label: string;
                        time: number;
                        privilegeId: string;
                    }[]>;
                    getUserPrivileges: (userId: string) => Promise<string[]>;
                };
                checker: import("../../../features/auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
                    "view all videos": string;
                    "moderate videos": string;
                }>;
                videoTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
                    "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
                }, import("../../../features/videos/types/video-tables.js").VideoTables>;
                access: import("../../../features/auth/types/auth-tokens.js").AccessPayload;
                authTables: import("../../../features/auth/types/auth-tables.js").AuthTables;
            }>>;
        };
    }>;
    storage: import("../../../toolbox/flex-storage/types/flex-storage.js").FlexStorage;
    authMediator: {
        subscribeToAccessChange: import("../../../toolbox/pubsub.js").Subscribe<import("../../../features/auth/mediator/types/access-event-listener.js").AccessEventListener>;
        subscribeToTokenChange: import("../../../toolbox/pubsub.js").Subscribe<() => void>;
        initialize(): Promise<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
        getValidAccess(): Promise<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
        getValidAccessToken(): Promise<string>;
        login(tokens: import("../../../features/auth/types/auth-tokens.js").AuthTokens): Promise<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
        logout(): Promise<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
        reauthorize(): Promise<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
    };
    popups: {
        triggerBankPopup: import("../../../features/store/model/shares/types/trigger-bank-popup.js").TriggerBankPopup;
    };
}>;
