import { AssembleModelsOptions } from "../types/assemble-models-options.js";
export declare function assembleModels({ appId, remote, popups, storage, authMediator, }: AssembleModelsOptions): Promise<{
    exampleModel: {
        state: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
        }>;
        subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
        }>) => void) => () => boolean;
        updateAccessOp: (op: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>) => void;
    };
    appsModel: {
        state: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            active: boolean;
            appRecords: import("../../../framework/ops.js").Op<import("../../../features/auth/aspects/apps/models/types/app-records.js").AppRecords>;
            addingNewApp: import("../../../framework/ops.js").Op<null>;
        }>;
        subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            active: boolean;
            appRecords: import("../../../framework/ops.js").Op<import("../../../features/auth/aspects/apps/models/types/app-records.js").AppRecords>;
            addingNewApp: import("../../../framework/ops.js").Op<null>;
        }>) => void) => () => boolean;
        appEditService: import("renraku/x/types/remote/remote").Remote<import("renraku/x/types/api/api-context").ApiContext<import("../../../features/auth/types/auth-metas.js").AppOwnerMeta, import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, {
            updateApp({ appTables, authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString, appDraft }: {
                appId: string;
                appDraft: import("../../../features/auth/aspects/apps/types/app-draft.js").AppDraft;
            }): Promise<void>;
            deleteApp({ appTables, authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString }: {
                appId: string;
            }): Promise<void>;
            listAdmins({ authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString }: {
                appId: string;
            }): Promise<import("../../../features/auth/aspects/apps/types/admin-email-display.js").AdminEmailDisplay[]>;
            assignPlatformUserAsAdmin({ authTablesForPlatform, authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString, platformUserId: platformUserIdString }: {
                appId: string;
                platformUserId: string;
            }): Promise<void>;
            assignAdmin({ authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString, email }: {
                appId: string;
                email: string;
            }): Promise<void>;
            revokeAdmin({ authorizeAppOwner }: import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, { appId: appIdString, userId: userIdString }: {
                appId: string;
                userId: string;
            }): Promise<void>;
        }, import("renraku/x/types/primitives/policy").Policy<import("../../../features/auth/types/auth-metas.js").AppOwnerMeta, import("../../../features/auth/types/auth-metas.js").AppOwnerAuth, import("renraku/x/types/http/http-request").HttpRequest>>>;
        getApp(appId: string): import("../../../features/auth/aspects/apps/types/app-display.js").AppDisplay;
        loadApps: () => Promise<import("../../../features/auth/aspects/apps/types/app-display.js").AppDisplay[]>;
        deleteApp: (appId: string) => Promise<void>;
        updateApp: (appId: string, appDraft: import("../../../features/auth/aspects/apps/types/app-draft.js").AppDraft) => Promise<void>;
        registerApp: (appDraft: import("../../../features/auth/aspects/apps/types/app-draft.js").AppDraft) => Promise<import("../../../features/auth/aspects/apps/types/app-display.js").AppDisplay>;
        updateAccessOp(op: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>): Promise<void>;
    };
    accessModel: {
        getAccessOp(): import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
        getAccess(): import("../../../features/auth/types/auth-tokens.js").AccessPayload;
        getValidAccess(): Promise<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
        useExistingLogin(): Promise<void>;
        sendLoginLink(email: string): Promise<void>;
        login(loginToken: string): Promise<void>;
        logout(): Promise<void>;
        reauthorize(): Promise<void>;
        readable: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
        }>;
        track: <X>(observer: import("../../../toolbox/snapstate/parts/types.js").Observer<{
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
        }, X>, reaction?: import("../../../toolbox/snapstate/parts/types.js").Reaction<X>) => () => void;
        subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
        }>) => void) => () => boolean;
    };
    videoModels: {
        dacastModel: {
            state: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
                linkedAccountOp: import("../../../framework/ops.js").Op<import("../../../features/videos/types/dacast-link.js").DacastLinkDisplay>;
            }>;
            subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
                linkedAccountOp: import("../../../framework/ops.js").Op<import("../../../features/videos/types/dacast-link.js").DacastLinkDisplay>;
            }>) => void) => () => boolean;
            onLinkChange: (listener: (context: import("../../../features/videos/types/dacast-link.js").DacastLinkDisplay) => void) => () => boolean;
            updateAccessOp(op: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>): Promise<void>;
            initialize(): Promise<void>;
            readonly linkedAccount: import("../../../features/videos/types/dacast-link.js").DacastLinkDisplay;
            linkAccount({ apiKey }: {
                apiKey: string;
            }): Promise<import("../../../features/videos/types/dacast-link.js").DacastLinkDisplay>;
            unlinkAccount(): Promise<void>;
        };
        contentModel: {
            state: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
                catalogOp: import("../../../framework/ops.js").Op<import("../../../features/videos/types/video-concepts.js").VideoHosting.DacastContent[]>;
                viewsOp: import("../../../framework/ops.js").Op<import("../../../features/videos/types/video-concepts.js").VideoView[]>;
                privilegesOp: import("../../../framework/ops.js").Op<import("../../../features/auth/aspects/users/routines/permissions/types/privilege-display.js").PrivilegeDisplay[]>;
                showsOp: import("../../../framework/ops.js").Op<import("../../../features/videos/types/video-concepts.js").VideoShow[]>;
            }>;
            subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
                catalogOp: import("../../../framework/ops.js").Op<import("../../../features/videos/types/video-concepts.js").VideoHosting.DacastContent[]>;
                viewsOp: import("../../../framework/ops.js").Op<import("../../../features/videos/types/video-concepts.js").VideoView[]>;
                privilegesOp: import("../../../framework/ops.js").Op<import("../../../features/auth/aspects/users/routines/permissions/types/privilege-display.js").PrivilegeDisplay[]>;
                showsOp: import("../../../framework/ops.js").Op<import("../../../features/videos/types/video-concepts.js").VideoShow[]>;
            }>) => void) => () => boolean;
            updateAccessOp(op: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>): Promise<void>;
            onVideoHostingUpdate(): Promise<void>;
            initialize: (label: string) => Promise<void>;
            loadModerationData: () => Promise<void>;
            readonly allowance: {
                canModerateVideos: boolean;
                canViewAllVideos: boolean;
            };
            readonly catalog: import("../../../features/videos/types/video-concepts.js").VideoHosting.DacastContent[];
            readonly views: import("../../../features/videos/types/video-concepts.js").VideoView[];
            readonly privileges: import("../../../features/auth/aspects/users/routines/permissions/types/privilege-display.js").PrivilegeDisplay[];
            readonly shows: import("../../../features/videos/types/video-concepts.js").VideoShow[];
            getView(label: string): import("../../../features/videos/types/video-concepts.js").VideoView;
            getPrivilege(id: string): import("../../../features/auth/aspects/users/routines/permissions/types/privilege-display.js").PrivilegeDisplay;
            getShow(label: string): import("../../../features/videos/types/video-concepts.js").VideoShow;
            setView(options: {
                label: string;
                privileges: string[];
                reference: import("../../../features/videos/types/video-concepts.js").VideoHosting.DacastReference;
            }): Promise<void>;
            deleteView(label: string): Promise<void>;
        };
        updateAccessOp(accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>): void;
    };
    personalModel: {
        track: <X_1>(observer: import("../../../toolbox/snapstate/parts/types.js").Observer<{
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
            submitDraftOp: import("../../../framework/ops.js").Op<void>;
        }, X_1>, reaction?: import("../../../toolbox/snapstate/parts/types.js").Reaction<X_1>) => () => void;
        subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
            submitDraftOp: import("../../../framework/ops.js").Op<void>;
        }>) => void) => () => boolean;
        readable: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
            submitDraftOp: import("../../../framework/ops.js").Op<void>;
        }>;
        saveProfile(profileDraft: import("../../../features/auth/aspects/users/routines/personal/types/profile-draft.js").ProfileDraft): Promise<void>;
        updateAccessOp(op: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>): void;
    };
    questionsModel: {
        onStateChange: import("../../../toolbox/pubsub.js").Subscribe<import("../../../toolbox/pubsub.js").AnyListener>;
        makeBoardModel: (board: string) => {
            getPermissions(): {
                readonly "read questions": boolean;
                readonly "post questions": boolean;
                readonly "moderate questions": boolean;
                readonly "answer questions": boolean;
                readonly "like questions": boolean;
                readonly "report questions": boolean;
            };
            getBoardName(): string;
            getAccess(): import("../../../features/auth/types/auth-tokens.js").AccessPayload;
            getBoardOp(): import("../../../framework/ops.js").Op<void>;
            getPostingOp(): import("../../../framework/ops.js").Op<void>;
            getQuestions(): {
                answers: import("../../../features/questions/api/types/questions-and-answers.js").Answer[];
                questionId: string;
                authorUserId: string;
                board: string;
                content: string;
                archive: boolean;
                timePosted: number;
                liked: boolean;
                likes: number;
                reports: number;
                reported: boolean;
            }[];
            getUser(userId: string): import("../../../features/auth/aspects/users/types/user.js").User;
            loadQuestions(): Promise<void>;
            postQuestion({ content }: {
                content: string;
            }): Promise<import("../../../features/questions/api/types/questions-and-answers.js").Question>;
            postAnswer(questionId: string, answerDraft: import("../../../features/questions/api/types/answer-draft.js").AnswerDraft): Promise<import("../../../features/questions/api/types/questions-and-answers.js").Answer>;
            likeQuestion(questionId: string, like: boolean): Promise<void>;
            likeAnswer(questionId: string, answerId: string, like: boolean): Promise<void>;
            reportQuestion(questionId: string, report: boolean): Promise<void>;
            reportAnswer(questionId: string, answerId: string, report: boolean): Promise<void>;
            archiveQuestion(questionId: string, archive: boolean): Promise<void>;
            archiveAnswer(questionId: string, answerId: string, archive: boolean): Promise<void>;
            archiveBoard(): Promise<void>;
        };
        accessChange: (access: import("../../../features/auth/types/auth-tokens.js").AccessPayload) => void;
    };
    livestreamModel: {
        state: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            rights: import("../../../features/livestream/models/types/livestream-rights.js").LivestreamRights;
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
            shows: {
                [label: string]: import("../../../framework/ops.js").Op<import("../../../features/livestream/api/types/livestream-tables.js").LivestreamShow>;
            };
        }>;
        subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            rights: import("../../../features/livestream/models/types/livestream-rights.js").LivestreamRights;
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
            shows: {
                [label: string]: import("../../../framework/ops.js").Op<import("../../../features/livestream/api/types/livestream-tables.js").LivestreamShow>;
            };
        }>) => void) => () => boolean;
        getShow: (label: string) => import("../../../framework/ops.js").Op<import("../../../features/livestream/api/types/livestream-tables.js").LivestreamShow>;
        commitShow: (show: import("../../../features/livestream/api/types/livestream-tables.js").LivestreamShow) => Promise<import("../../../features/livestream/api/types/livestream-tables.js").LivestreamShow>;
        loadShow: import("../../../toolbox/debounce/debounce-types.js").DebounceReturn<(label: string) => Promise<void>>;
        updateAccessOp(op: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>): Promise<void>;
    };
    permissionsModel: {
        readable: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            active: boolean;
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
            permissionsDisplay: import("../../../framework/ops.js").Op<import("../../../features/auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
        }>;
        subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            active: boolean;
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
            permissionsDisplay: import("../../../framework/ops.js").Op<import("../../../features/auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
        }>) => void) => () => boolean;
        track: <X_2>(observer: import("../../../toolbox/snapstate/parts/types.js").Observer<{
            active: boolean;
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
            permissionsDisplay: import("../../../framework/ops.js").Op<import("../../../features/auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
        }, X_2>, reaction?: import("../../../toolbox/snapstate/parts/types.js").Reaction<X_2>) => () => void;
        getAccess: () => import("../../../features/auth/types/auth-tokens.js").AccessPayload;
        initialize: () => Promise<void>;
        getUserCanCustomizePermissions: () => boolean;
        createRole: (args_0: {
            label: string;
        }) => Promise<void>;
        deleteRole: (args_0: {
            roleId: string;
        }) => Promise<void>;
        assignPrivilege: (args_0: {
            roleId: string;
            privilegeId: string;
        }) => Promise<void>;
        unassignPrivilege: (args_0: {
            roleId: string;
            privilegeId: string;
        }) => Promise<void>;
        deletePrivilege: (args_0: {
            privilegeId: string;
        }) => Promise<void>;
        createPrivilege: (args_0: {
            label: string;
        }) => Promise<import("../../../features/auth/aspects/users/routines/permissions/types/privilege-display.js").PrivilegeDisplay>;
        updateAccessOp(op: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>): Promise<void>;
    };
    administrativeModel: {
        state: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
            permissionsOp: import("../../../framework/ops.js").Op<import("../../../features/auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
        }>;
        subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
            accessOp: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>;
            permissionsOp: import("../../../framework/ops.js").Op<import("../../../features/auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
        }>) => void) => () => boolean;
        getAccess: () => import("../../../features/auth/types/auth-tokens.js").AccessPayload;
        initialize: () => Promise<void>;
        readonly isAllowed: (privilege: "universal" | "banned" | "read questions" | "post questions" | "like questions" | "report questions" | "view livestream" | "view all videos" | "moderate videos" | "edit any profile" | "customize permissions" | "answer questions" | "moderate questions" | "view stats" | "administrate user roles" | "moderate livestream" | "manage store" | "give away freebies") => boolean;
        reauthorize: () => Promise<void>;
        searchUsers: (args_0: {
            term: string;
        }) => Promise<{
            user: {
                userId: string;
                profile: import("../../../features/auth/aspects/users/types/profile.js").Profile;
                roles: import("../../../features/auth/aspects/users/types/public-user-role.js").PublicUserRole[];
                stats: import("../../../features/auth/aspects/users/types/user-stats.js").UserStats;
            };
            roleIds: string[];
        }[]>;
        assignRoleToUser: (args_0: {
            roleId: string;
            userId: string;
            isPublic: boolean;
            timeframeEnd: number;
            timeframeStart: number;
        }) => Promise<void>;
        revokeRoleFromUser: (args_0: {
            roleId: string;
            userId: string;
        }) => Promise<void>;
        updateAccessOp(op: import("../../../framework/ops.js").Op<import("../../../features/auth/types/auth-tokens.js").AccessPayload>): Promise<void>;
    };
}>;
