import { AdministrativeOptions } from "./types/administrative-options.js";
export declare function makeAdministrativeApi(options: AdministrativeOptions): {
    roleAssignmentService: import("renraku/x/types/api/api-context").ApiContext<import("../../auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsMeta, import("../../auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, {
        fetchPermissions({ engine }: import("../../auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth): Promise<import("../../auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
        searchUsers({ access, engine, authTables }: import("../../auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, options: {
            term: string;
        }): Promise<{
            user: {
                userId: string;
                profile: import("../../auth/aspects/users/types/profile.js").Profile;
                roles: import("../../auth/aspects/users/types/public-user-role.js").PublicUserRole[];
                stats: import("../../auth/aspects/users/types/user-stats.js").UserStats;
            };
            roleIds: string[];
        }[]>;
        assignRoleToUser({ authTables }: import("../../auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, options: {
            roleId: string;
            userId: string;
            isPublic: boolean;
            timeframeEnd: number;
            timeframeStart: number;
        }): Promise<void>;
        revokeRoleFromUser({ authTables }: import("../../auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsAuth, options: {
            roleId: string;
            userId: string;
        }): Promise<void>;
    }, (meta: import("../../auth/aspects/permissions/types/permissions-auth-and-metas.js").PermissionsMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
        engine: {
            getUsersHaveRoles: ({ userIds, onlyGetPublicRoles }: {
                userIds: string[];
                onlyGetPublicRoles: boolean;
            }) => Promise<{
                userId: string;
                userHasRoles: {
                    userId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                    roleId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                    timeframeStart: number;
                    timeframeEnd: number;
                    public: boolean;
                    hard: boolean;
                    time: number;
                }[];
            }[]>;
            getAnonymousPrivileges: () => Promise<string[]>;
            getPrivilegesForUsers: (userIds: string[]) => Promise<{
                userId: string;
                privileges: string[];
            }[]>;
            getPublicRolesForUsers: (userIds: string[]) => Promise<{
                userId: string;
                publicUserRoles: import("../../auth/aspects/users/types/public-user-role.js").PublicUserRole[];
            }[]>;
            getPermissionsDisplay: () => Promise<import("../../auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
            getPrivileges: (privilegeIds: string[]) => Promise<{
                hard: boolean;
                label: string;
                time: number;
                privilegeId: string;
            }[]>;
            getAllPrivileges: () => Promise<{
                hard: boolean;
                label: string;
                time: number;
                privilegeId: string;
            }[]>;
            getUserPrivileges: (userId: string) => Promise<string[]>;
        };
        access: import("../../auth/types/auth-tokens.js").AccessPayload;
        authTables: import("../../auth/types/auth-tables.js").AuthTables;
        checker: import("../../auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
            "manage store": string;
            "give away freebies": string;
            universal: string;
            banned: string;
            "view all videos": string;
            "moderate videos": string;
            "edit any profile": string;
            "customize permissions": string;
            "answer questions": string;
            "moderate questions": string;
            "view stats": string;
            "administrate user roles": string;
            "moderate livestream": string;
            "read questions": string;
            "post questions": string;
            "like questions": string;
            "report questions": string;
            "view livestream": string;
        }>;
    }>>;
};
