import { AppDisplay } from "../../../types/app-display.js";
import { Service } from "../../../../../../../types/service.js";
import { makeAppEditService } from "../../../services/app-edit-service.js";
export declare function makeAdminManager({ app, appEditService, query }: {
    app: AppDisplay;
    appEditService: Service<typeof makeAppEditService>;
    query: <E extends HTMLElement>(selector: string) => E;
}): {
    render: () => import("lit-html").TemplateResult<1>;
    controls: {
        listAdmins: () => Promise<void>;
        assignAdmin: () => Promise<void>;
        revokeAdmin: (userId: string) => Promise<void>;
    };
    track: <X>(stakeout: import("../../../../../../../toolbox/autowatcher/types/autowatcher-types.js").Stakeout<X>) => () => void;
};
