import { Op } from "../../../../../framework/ops.js";
import { AccessPayload } from "../../../types/auth-tokens.js";
import { PermissionsModelOptions } from "./types/permissions-model-options.js";
import { PrivilegeDisplay } from "../../users/routines/permissions/types/privilege-display.js";
import { PermissionsDisplay } from "../../users/routines/permissions/types/permissions-display.js";
export declare function makePermissionsModel({ permissionsService, reauthorize, }: PermissionsModelOptions): {
    readable: import("../../../../../toolbox/snapstate/parts/types.js").Readable<{
        active: boolean;
        accessOp: Op<AccessPayload>;
        permissionsDisplay: Op<PermissionsDisplay>;
    }>;
    subscribe: (listener: (context: import("../../../../../toolbox/snapstate/parts/types.js").Readable<{
        active: boolean;
        accessOp: Op<AccessPayload>;
        permissionsDisplay: Op<PermissionsDisplay>;
    }>) => void) => () => boolean;
    track: <X>(observer: import("../../../../../toolbox/snapstate/parts/types.js").Observer<{
        active: boolean;
        accessOp: Op<AccessPayload>;
        permissionsDisplay: Op<PermissionsDisplay>;
    }, X>, reaction?: import("../../../../../toolbox/snapstate/parts/types.js").Reaction<X>) => () => void;
    getAccess: () => AccessPayload;
    initialize: () => Promise<void>;
    getUserCanCustomizePermissions: () => boolean;
    createRole: (args_0: {
        label: string;
    }) => Promise<void>;
    deleteRole: (args_0: {
        roleId: string;
    }) => Promise<void>;
    assignPrivilege: (args_0: {
        roleId: string;
        privilegeId: string;
    }) => Promise<void>;
    unassignPrivilege: (args_0: {
        roleId: string;
        privilegeId: string;
    }) => Promise<void>;
    deletePrivilege: (args_0: {
        privilegeId: string;
    }) => Promise<void>;
    createPrivilege: (args_0: {
        label: string;
    }) => Promise<PrivilegeDisplay>;
    updateAccessOp(op: Op<AccessPayload>): Promise<void>;
};
