import { AuthOptions } from "../../../types/auth-options.js";
import { DamnId } from "../../../../../toolbox/damnedb/damn-id.js";
import { PermissionsAuth, PermissionsMeta } from "../types/permissions-auth-and-metas.js";
import { PrivilegeDisplay } from "../../users/routines/permissions/types/privilege-display.js";
export declare const makePermissionsService: ({ rando, config, authPolicies, }: AuthOptions) => import("renraku/x/types/api/api-context").ApiContext<PermissionsMeta, PermissionsAuth, {
    fetchPermissions({ engine }: PermissionsAuth): Promise<import("../../users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
    createRole({ authTables }: PermissionsAuth, { label }: {
        label: string;
    }): Promise<void>;
    deleteRole({ authTables }: PermissionsAuth, { roleId: roleIdString }: {
        roleId: string;
    }): Promise<void>;
    assignPrivilege({ authTables }: PermissionsAuth, { roleId: roleIdString, privilegeId: privilegeIdString }: {
        roleId: string;
        privilegeId: string;
    }): Promise<void>;
    unassignPrivilege({ authTables }: PermissionsAuth, { roleId: roleIdString, privilegeId: privilegeIdString }: {
        roleId: string;
        privilegeId: string;
    }): Promise<void>;
    createPrivilege({ authTables }: PermissionsAuth, { label }: {
        label: string;
    }): Promise<PrivilegeDisplay>;
    deletePrivilege({ engine, authTables }: PermissionsAuth, { privilegeId: privilegeIdString }: {
        privilegeId: string;
    }): Promise<void>;
}, (meta: PermissionsMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
    engine: {
        getUsersHaveRoles: ({ userIds, onlyGetPublicRoles }: {
            userIds: string[];
            onlyGetPublicRoles: boolean;
        }) => Promise<{
            userId: string;
            userHasRoles: {
                userId: DamnId;
                roleId: DamnId;
                timeframeStart: number;
                timeframeEnd: number;
                public: boolean;
                hard: boolean;
                time: number;
            }[];
        }[]>;
        getAnonymousPrivileges: () => Promise<string[]>;
        getPrivilegesForUsers: (userIds: string[]) => Promise<{
            userId: string;
            privileges: string[];
        }[]>;
        getPublicRolesForUsers: (userIds: string[]) => Promise<{
            userId: string;
            publicUserRoles: import("../../users/types/public-user-role.js").PublicUserRole[];
        }[]>;
        getPermissionsDisplay: () => Promise<import("../../users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
        getPrivileges: (privilegeIds: string[]) => Promise<{
            hard: boolean;
            label: string;
            time: number;
            privilegeId: string;
        }[]>;
        getAllPrivileges: () => Promise<{
            hard: boolean;
            label: string;
            time: number;
            privilegeId: string;
        }[]>;
        getUserPrivileges: (userId: string) => Promise<string[]>;
    };
    access: import("../../../types/auth-tokens.js").AccessPayload;
    authTables: import("../../../types/auth-tables.js").AuthTables;
    checker: import("../types/privilege-checker.js").PrivilegeChecker<{
        "manage store": string;
        "give away freebies": string;
        universal: string;
        banned: string;
        "view all videos": string;
        "moderate videos": string;
        "edit any profile": string;
        "customize permissions": string;
        "answer questions": string;
        "moderate questions": string;
        "view stats": string;
        "administrate user roles": string;
        "moderate livestream": string;
        "read questions": string;
        "post questions": string;
        "like questions": string;
        "report questions": string;
        "view livestream": string;
    }>;
}>>;
