import { DamnId } from "../../../../../toolbox/damnedb/damn-id.js";
import { AsDbbyRow, DbbyTable } from "../../../../../toolbox/dbby/dbby-types.js";
export declare type PermissionsTables = {
    role: DbbyTable<RoleRow>;
    privilege: DbbyTable<PrivilegeRow>;
    userHasRole: DbbyTable<UserHasRoleRow>;
    roleHasPrivilege: DbbyTable<RoleHasPrivilegeRow>;
};
export declare type RoleRow = AsDbbyRow<{
    roleId: DamnId;
    label: string;
    time: number;
    hard: boolean;
    public: boolean;
    assignable: boolean;
}>;
export declare type PrivilegeRow = AsDbbyRow<{
    privilegeId: DamnId;
    label: string;
    hard: boolean;
    time: number;
}>;
export declare type UserHasRoleRow = AsDbbyRow<{
    userId: DamnId;
    roleId: DamnId;
    timeframeStart: undefined | number;
    timeframeEnd: undefined | number;
    public: boolean;
    hard: boolean;
    time: number;
}>;
export declare type RoleHasPrivilegeRow = AsDbbyRow<{
    roleId: DamnId;
    privilegeId: DamnId;
    immutable: boolean;
    active: boolean;
    time: number;
}>;
