import { apiContext } from "renraku/x/api/api-context.js";
import { DamnId } from "../../../../toolbox/damnedb/damn-id.js";
export const makeExampleService = ({ rando, config, authPolicies, exampleTables, }) => apiContext()({
    policy: async (meta, request) => {
        const auth = await authPolicies.userPolicy(meta, request);
        const appId = DamnId.fromString(auth.access.appId);
        return {
            ...auth,
            exampleTables: exampleTables.namespaceForApp(appId),
        };
    },
    expose: {
        async exampleFunction({ access, exampleTables }, { something }) {
            await exampleTables.examplePosts.create({
                exampleId: rando.randomId(),
                something,
            });
        }
    },
});
//# sourceMappingURL=example-service.js.map