import { LivestreamApiOptions } from "./types/livestream-api-options.js";
export declare function livestreamApi(options: LivestreamApiOptions): {
    livestreamViewingService: import("renraku/x/types/api/api-context").ApiContext<import("../../auth/types/auth-metas.js").UserMeta, import("./types/livestream-auths.js").LivestreamAuth, {
        getShows({ livestreamTables }: import("./types/livestream-auths.js").LivestreamAuth, inputs: {
            labels: string[];
        }): Promise<import("./types/livestream-tables.js").LivestreamShow[]>;
    }, (meta: import("../../auth/types/auth-metas.js").UserMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
        livestreamTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
            "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
        }, import("./types/livestream-tables.js").LivestreamTables>;
        access: import("../../auth/types/auth-tokens.js").AccessPayload;
        authTables: import("../../auth/types/auth-tables.js").AuthTables;
        checker: import("../../auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
            "manage store": string;
            "give away freebies": string;
            universal: string;
            banned: string;
            "view all videos": string;
            "moderate videos": string;
            "edit any profile": string;
            "customize permissions": string;
            "answer questions": string;
            "moderate questions": string;
            "view stats": string;
            "administrate user roles": string;
            "moderate livestream": string;
            "read questions": string;
            "post questions": string;
            "like questions": string;
            "report questions": string;
            "view livestream": string;
        }>;
    }>>;
    livestreamModerationService: import("renraku/x/types/api/api-context").ApiContext<import("../../auth/types/auth-metas.js").UserMeta, import("./types/livestream-auths.js").LivestreamAuth, {
        setShow({ livestreamTables }: import("./types/livestream-auths.js").LivestreamAuth, inputs: {
            label: string;
            vimeoId: string;
        }): Promise<void>;
    }, (meta: import("../../auth/types/auth-metas.js").UserMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
        livestreamTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
            "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
        }, import("./types/livestream-tables.js").LivestreamTables>;
        access: import("../../auth/types/auth-tokens.js").AccessPayload;
        authTables: import("../../auth/types/auth-tables.js").AuthTables;
        checker: import("../../auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
            "manage store": string;
            "give away freebies": string;
            universal: string;
            banned: string;
            "view all videos": string;
            "moderate videos": string;
            "edit any profile": string;
            "customize permissions": string;
            "answer questions": string;
            "moderate questions": string;
            "view stats": string;
            "administrate user roles": string;
            "moderate livestream": string;
            "read questions": string;
            "post questions": string;
            "like questions": string;
            "report questions": string;
            "view livestream": string;
        }>;
    }>>;
};
