import { UserMeta } from "../../../auth/types/auth-metas.js";
import { LivestreamAuth } from "../types/livestream-auths.js";
import { DamnId } from "../../../../toolbox/damnedb/damn-id.js";
import { LivestreamApiOptions } from "../types/livestream-api-options.js";
export declare const makeLivestreamModerationService: ({ authPolicies, livestreamTables, }: LivestreamApiOptions) => import("renraku/x/types/api/api-context").ApiContext<UserMeta, LivestreamAuth, {
    setShow({ livestreamTables }: LivestreamAuth, inputs: {
        label: string;
        vimeoId: undefined | null | string;
    }): Promise<void>;
}, (meta: UserMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
    livestreamTables: import("../../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
        "namespace-appId": DamnId;
    }, import("../types/livestream-tables.js").LivestreamTables>;
    access: import("../../../auth/types/auth-tokens.js").AccessPayload;
    authTables: import("../../../auth/types/auth-tables.js").AuthTables;
    checker: import("../../../auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
        "manage store": string;
        "give away freebies": string;
        universal: string;
        banned: string;
        "view all videos": string;
        "moderate videos": string;
        "edit any profile": string;
        "customize permissions": string;
        "answer questions": string;
        "moderate questions": string;
        "view stats": string;
        "administrate user roles": string;
        "moderate livestream": string;
        "read questions": string;
        "post questions": string;
        "like questions": string;
        "report questions": string;
        "view livestream": string;
    }>;
}>>;
