var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _XiomeLivestream_instances, _XiomeLivestream_renderStreamViewer, _XiomeLivestream_getCurrentVimeoId, _XiomeLivestream_changed, _XiomeLivestream_vimeoIdDraft, _XiomeLivestream_vimeoFieldOnValueChange, _XiomeLivestream_vimeoIdDraftIsDifferent, _XiomeLivestream_submitVimeoId, _XiomeLivestream_renderModBox, _XiomeLivestream_renderForRights;
import { ComponentWithShare, html, mixinStyles, property } from "../../../../framework/component.js";
import styles from "./styles/xiome-livestream.css.js";
import { LivestreamRights } from "../../models/types/livestream-rights.js";
import { renderOp } from "../../../../framework/op-rendering/render-op.js";
import { validateVimeoField } from "../../api/validation/livestream-validators.js";
import { generateVimeoUrl } from "../../models/utils/generate-vimeo-url.js";
import { ops } from "../../../../framework/ops.js";
import { parseVimeoId } from "../../models/utils/parse-vimeo-id.js";
let XiomeLivestream = class XiomeLivestream extends ComponentWithShare {
    constructor() {
        super(...arguments);
        _XiomeLivestream_instances.add(this);
        this.label = "default";
        _XiomeLivestream_renderStreamViewer.set(this, () => {
            const showOp = this.share.livestreamModel.getShow(this.label);
            return renderOp(showOp, show => html `
			<p>
				${show.vimeoId
                ? `label "${show.label}", vimeo id ${show.vimeoId}`
                : `no vimeo id for show "${show.label}"`}
			</p>
		`);
        });
        _XiomeLivestream_changed.set(this, false);
        _XiomeLivestream_vimeoIdDraft.set(this, void 0);
        _XiomeLivestream_renderModBox.set(this, () => {
            const showOp = this.share.livestreamModel.getShow(this.label);
            const currentVimeoId = __classPrivateFieldGet(this, _XiomeLivestream_instances, "m", _XiomeLivestream_getCurrentVimeoId).call(this);
            const currentVimeoUrl = currentVimeoId.length
                ? generateVimeoUrl(currentVimeoId)
                : "";
            const draftIsDifferent = __classPrivateFieldGet(this, _XiomeLivestream_instances, "m", _XiomeLivestream_vimeoIdDraftIsDifferent).call(this);
            return renderOp(showOp, () => html `
			<div class=modbox>
				<xio-text-input
					class=vimeo-field
					.initial="${currentVimeoUrl}"
					show-validation-when-empty
					?hide-validation=${!draftIsDifferent}
					.validator=${validateVimeoField}
					?disabled=${!ops.isReady(showOp)}
					@valuechange=${__classPrivateFieldGet(this, _XiomeLivestream_instances, "m", _XiomeLivestream_vimeoFieldOnValueChange)}>
						vimeo url
				</xio-text-input>
				<xio-button
					?disabled=${!draftIsDifferent}
					@press=${__classPrivateFieldGet(this, _XiomeLivestream_instances, "m", _XiomeLivestream_submitVimeoId)}>
						set livestream
				</xio-button>
			</div>
		`);
        });
        _XiomeLivestream_renderForRights.set(this, () => {
            switch (this.share.livestreamModel.state.rights) {
                case LivestreamRights.Forbidden: return html `
				<p>you are forbidden lol</p>
			`;
                case LivestreamRights.Viewer: return html `
				<p>you are viewer</p>
				${__classPrivateFieldGet(this, _XiomeLivestream_renderStreamViewer, "f").call(this)}
			`;
                case LivestreamRights.Moderator: return html `
				<p>you are moderator</p>
				${__classPrivateFieldGet(this, _XiomeLivestream_renderModBox, "f").call(this)}
				${__classPrivateFieldGet(this, _XiomeLivestream_renderStreamViewer, "f").call(this)}
			`;
            }
        });
    }
    get state() {
        return this.share.livestreamModel.state;
    }
    updated(props) {
        if (props.has("label") && props.get("label") !== this.label)
            this.share.livestreamModel.loadShow(this.label);
    }
    render() {
        return renderOp(this.state.accessOp, __classPrivateFieldGet(this, _XiomeLivestream_renderForRights, "f"));
    }
};
_XiomeLivestream_renderStreamViewer = new WeakMap(), _XiomeLivestream_changed = new WeakMap(), _XiomeLivestream_vimeoIdDraft = new WeakMap(), _XiomeLivestream_renderModBox = new WeakMap(), _XiomeLivestream_renderForRights = new WeakMap(), _XiomeLivestream_instances = new WeakSet(), _XiomeLivestream_getCurrentVimeoId = function _XiomeLivestream_getCurrentVimeoId() {
    const showOp = this.share.livestreamModel.getShow(this.label);
    const show = ops.value(showOp);
    return (show && show.vimeoId)
        ? show.vimeoId
        : "";
}, _XiomeLivestream_vimeoFieldOnValueChange = function _XiomeLivestream_vimeoFieldOnValueChange({ detail: { value } }) {
    __classPrivateFieldSet(this, _XiomeLivestream_changed, true, "f");
    __classPrivateFieldSet(this, _XiomeLivestream_vimeoIdDraft, value
        ? parseVimeoId(value)
        : "", "f");
    this.requestUpdate();
}, _XiomeLivestream_vimeoIdDraftIsDifferent = function _XiomeLivestream_vimeoIdDraftIsDifferent() {
    const showOp = this.share.livestreamModel.getShow(this.label);
    return __classPrivateFieldGet(this, _XiomeLivestream_changed, "f") && ops.isReady(showOp)
        ? __classPrivateFieldGet(this, _XiomeLivestream_vimeoIdDraft, "f") !== __classPrivateFieldGet(this, _XiomeLivestream_instances, "m", _XiomeLivestream_getCurrentVimeoId).call(this)
        : false;
}, _XiomeLivestream_submitVimeoId = function _XiomeLivestream_submitVimeoId() {
    __classPrivateFieldSet(this, _XiomeLivestream_changed, false, "f");
    const vimeoId = __classPrivateFieldGet(this, _XiomeLivestream_vimeoIdDraft, "f");
    this.share.livestreamModel.commitShow({
        vimeoId,
        label: this.label,
    });
};
__decorate([
    property({ type: String, reflect: true })
], XiomeLivestream.prototype, "label", void 0);
XiomeLivestream = __decorate([
    mixinStyles(styles)
], XiomeLivestream);
export { XiomeLivestream };
//# sourceMappingURL=xiome-livestream.js.map