import { Op } from "../../../framework/ops.js";
import { Service } from "../../../types/service.js";
import { AccessPayload } from "../../auth/types/auth-tokens.js";
import { LivestreamRights } from "./types/livestream-rights.js";
import { LivestreamShow } from "../api/types/livestream-tables.js";
import { makeLivestreamViewingService } from "../api/services/livestream-viewing-service.js";
import { makeLivestreamModerationService } from "../api/services/livestream-moderation-service.js";
export declare function makeLivestreamModel({ livestreamViewingService, livestreamModerationService, getAccessOp, }: {
    livestreamViewingService: Service<typeof makeLivestreamViewingService>;
    livestreamModerationService: Service<typeof makeLivestreamModerationService>;
    getAccessOp: () => Op<AccessPayload>;
}): {
    state: import("../../../toolbox/snapstate/parts/types.js").Readable<{
        rights: LivestreamRights;
        accessOp: Op<AccessPayload>;
        shows: {
            [label: string]: Op<LivestreamShow>;
        };
    }>;
    subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
        rights: LivestreamRights;
        accessOp: Op<AccessPayload>;
        shows: {
            [label: string]: Op<LivestreamShow>;
        };
    }>) => void) => () => boolean;
    getShow: (label: string) => Op<LivestreamShow>;
    commitShow: (show: LivestreamShow) => Promise<LivestreamShow>;
    loadShow: import("../../../toolbox/debounce/debounce-types.js").DebounceReturn<(label: string) => Promise<void>>;
    updateAccessOp(op: Op<AccessPayload>): Promise<void>;
};
