import { Policy } from "renraku/x/types/primitives/policy.js";
import { VideoTables } from "../../types/video-tables.js";
import { Dacast } from "../../dacast/types/dacast-types.js";
import { DamnId } from "../../../../toolbox/damnedb/damn-id.js";
import { VideoAuth, VideoMeta } from "../../types/video-auth.js";
import { AnonAuth, AnonMeta } from "../../../auth/types/auth-metas.js";
import { SecretConfig } from "../../../../assembly/backend/types/secret-config.js";
import { VideoHosting, VideoModerationData, VideoShow } from "../../types/video-concepts.js";
import { UnconstrainedTables } from "../../../../framework/api/types/table-namespacing-for-apps.js";
export declare const makeContentService: ({ config, dacastSdk, videoTables: rawVideoTables, basePolicy, }: {
    config: SecretConfig;
    dacastSdk: Dacast.Sdk;
    videoTables: UnconstrainedTables<VideoTables>;
    basePolicy: Policy<AnonMeta, AnonAuth>;
}) => import("renraku/x/types/api/api-context").ApiContext<VideoMeta, VideoAuth, {
    fetchModerationData({ access, authTables, videoTables, checker, }: VideoAuth): Promise<VideoModerationData>;
    writeView({ videoTables, checker, engine }: VideoAuth, { label, privileges, reference, }: {
        label: string;
        privileges: string[];
        reference: VideoHosting.AnyReference;
    }): Promise<void>;
    deleteView({ videoTables, checker }: VideoAuth, { label }: {
        label: string;
    }): Promise<void>;
    getShows({ videoTables, access, checker }: VideoAuth, { labels }: {
        labels: string[];
    }): Promise<VideoShow[]>;
}, (meta: VideoMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
    engine: {
        getUsersHaveRoles: ({ userIds, onlyGetPublicRoles }: {
            userIds: string[];
            onlyGetPublicRoles: boolean;
        }) => Promise<{
            userId: string;
            userHasRoles: {
                userId: DamnId;
                roleId: DamnId;
                timeframeStart: number;
                timeframeEnd: number;
                public: boolean;
                hard: boolean;
                time: number;
            }[];
        }[]>;
        getAnonymousPrivileges: () => Promise<string[]>;
        getPrivilegesForUsers: (userIds: string[]) => Promise<{
            userId: string;
            privileges: string[];
        }[]>;
        getPublicRolesForUsers: (userIds: string[]) => Promise<{
            userId: string;
            publicUserRoles: import("../../../auth/aspects/users/types/public-user-role.js").PublicUserRole[];
        }[]>;
        getPermissionsDisplay: () => Promise<import("../../../auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
        getPrivileges: (privilegeIds: string[]) => Promise<{
            hard: boolean;
            label: string;
            time: number;
            privilegeId: string;
        }[]>;
        getAllPrivileges: () => Promise<{
            hard: boolean;
            label: string;
            time: number;
            privilegeId: string;
        }[]>;
        getUserPrivileges: (userId: string) => Promise<string[]>;
    };
    checker: import("../../../auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
        "view all videos": string;
        "moderate videos": string;
    }>;
    videoTables: import("../../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
        "namespace-appId": DamnId;
    }, VideoTables>;
    access: import("../../../auth/types/auth-tokens.js").AccessPayload;
    authTables: import("../../../auth/types/auth-tables.js").AuthTables;
}>>;
