import { ingestDacastContent } from "./ingest-dacast-content.js";
import { concurrent } from "../../../../../toolbox/concurrent.js";
export async function getCatalog({ dacast }) {
    const results = await concurrent({
        vods: dacast.vods.get(),
        channels: dacast.channels.get(),
        playlists: dacast.playlists.get(),
    });
    function convert2(type, paginated) {
        return (paginated?.data ?? []).map(data => ingestDacastContent({
            type,
            data,
        }));
    }
    return [
        ...convert2("vod", results.vods),
        ...convert2("channel", results.channels),
        ...convert2("playlist", results.playlists),
    ];
}
//# sourceMappingURL=get-catalog.js.map