import { VideoTables } from "../types/video-tables.js";
import { Dacast } from "../dacast/types/dacast-types.js";
import { SecretConfig } from "../../../assembly/backend/types/secret-config.js";
import { prepareAuthPolicies } from "../../auth/policies/prepare-auth-policies.js";
import { UnconstrainedTables } from "../../../framework/api/types/table-namespacing-for-apps.js";
export declare function videosApi({ config, videoTables, authPolicies, dacastSdk, }: {
    config: SecretConfig;
    videoTables: UnconstrainedTables<VideoTables>;
    authPolicies: ReturnType<typeof prepareAuthPolicies>;
    dacastSdk: Dacast.Sdk;
}): {
    dacastService: import("renraku/x/types/api/api-context").ApiContext<import("../types/video-auth.js").VideoMeta, import("../types/video-auth.js").VideoAuth, {
        getLink({ videoTables }: import("../types/video-auth.js").VideoAuth): Promise<import("../types/dacast-link.js").DacastLinkDisplay>;
        setLink({ videoTables }: import("../types/video-auth.js").VideoAuth, inputs: {
            apiKey: string;
        }): Promise<import("../types/dacast-link.js").DacastLinkDisplay>;
        clearLink({ videoTables }: import("../types/video-auth.js").VideoAuth): Promise<void>;
    }, (meta: import("../types/video-auth.js").VideoMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
        checker: import("../../auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
            "view all videos": string;
            "moderate videos": string;
        }>;
        engine: {
            getUsersHaveRoles: ({ userIds, onlyGetPublicRoles }: {
                userIds: string[];
                onlyGetPublicRoles: boolean;
            }) => Promise<{
                userId: string;
                userHasRoles: {
                    userId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                    roleId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                    timeframeStart: number;
                    timeframeEnd: number;
                    public: boolean;
                    hard: boolean;
                    time: number;
                }[];
            }[]>;
            getAnonymousPrivileges: () => Promise<string[]>;
            getPrivilegesForUsers: (userIds: string[]) => Promise<{
                userId: string;
                privileges: string[];
            }[]>;
            getPublicRolesForUsers: (userIds: string[]) => Promise<{
                userId: string;
                publicUserRoles: import("../../auth/aspects/users/types/public-user-role.js").PublicUserRole[];
            }[]>;
            getPermissionsDisplay: () => Promise<import("../../auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
            getPrivileges: (privilegeIds: string[]) => Promise<{
                hard: boolean;
                label: string;
                time: number;
                privilegeId: string;
            }[]>;
            getAllPrivileges: () => Promise<{
                hard: boolean;
                label: string;
                time: number;
                privilegeId: string;
            }[]>;
            getUserPrivileges: (userId: string) => Promise<string[]>;
        };
        videoTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
            "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
        }, VideoTables>;
        access: import("../../auth/types/auth-tokens.js").AccessPayload;
        authTables: import("../../auth/types/auth-tables.js").AuthTables;
    }>>;
    contentService: import("renraku/x/types/api/api-context").ApiContext<import("../types/video-auth.js").VideoMeta, import("../types/video-auth.js").VideoAuth, {
        fetchModerationData({ access, authTables, videoTables, checker, }: import("../types/video-auth.js").VideoAuth): Promise<import("../types/video-concepts.js").VideoModerationData>;
        writeView({ videoTables, checker, engine }: import("../types/video-auth.js").VideoAuth, { label, privileges, reference, }: {
            label: string;
            privileges: string[];
            reference: import("../types/video-concepts.js").VideoHosting.DacastReference;
        }): Promise<void>;
        deleteView({ videoTables, checker }: import("../types/video-auth.js").VideoAuth, { label }: {
            label: string;
        }): Promise<void>;
        getShows({ videoTables, access, checker }: import("../types/video-auth.js").VideoAuth, { labels }: {
            labels: string[];
        }): Promise<import("../types/video-concepts.js").VideoShow[]>;
    }, (meta: import("../types/video-auth.js").VideoMeta, request: import("renraku/x/types/http/http-request").HttpRequest) => Promise<{
        engine: {
            getUsersHaveRoles: ({ userIds, onlyGetPublicRoles }: {
                userIds: string[];
                onlyGetPublicRoles: boolean;
            }) => Promise<{
                userId: string;
                userHasRoles: {
                    userId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                    roleId: import("../../../toolbox/damnedb/damn-id.js").DamnId;
                    timeframeStart: number;
                    timeframeEnd: number;
                    public: boolean;
                    hard: boolean;
                    time: number;
                }[];
            }[]>;
            getAnonymousPrivileges: () => Promise<string[]>;
            getPrivilegesForUsers: (userIds: string[]) => Promise<{
                userId: string;
                privileges: string[];
            }[]>;
            getPublicRolesForUsers: (userIds: string[]) => Promise<{
                userId: string;
                publicUserRoles: import("../../auth/aspects/users/types/public-user-role.js").PublicUserRole[];
            }[]>;
            getPermissionsDisplay: () => Promise<import("../../auth/aspects/users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
            getPrivileges: (privilegeIds: string[]) => Promise<{
                hard: boolean;
                label: string;
                time: number;
                privilegeId: string;
            }[]>;
            getAllPrivileges: () => Promise<{
                hard: boolean;
                label: string;
                time: number;
                privilegeId: string;
            }[]>;
            getUserPrivileges: (userId: string) => Promise<string[]>;
        };
        checker: import("../../auth/aspects/permissions/types/privilege-checker.js").PrivilegeChecker<{
            "view all videos": string;
            "moderate videos": string;
        }>;
        videoTables: import("../../../toolbox/dbby/dbby-types.js").DbbyConstrainTables<{
            "namespace-appId": import("../../../toolbox/damnedb/damn-id.js").DamnId;
        }, VideoTables>;
        access: import("../../auth/types/auth-tokens.js").AccessPayload;
        authTables: import("../../auth/types/auth-tables.js").AuthTables;
    }>>;
};
