import { VideoHosting } from "../../types/video-concepts.js";
import { makeContentModel } from "../../models/parts/content-model.js";
import { ComponentWithShare } from "../../../../framework/component.js";
export declare class XiomeVideoDisplay extends ComponentWithShare<{
    contentModel: ReturnType<typeof makeContentModel>;
}> {
    #private;
    label: string;
    get model(): {
        state: import("../../../../toolbox/snapstate/parts/types.js").Readable<{
            accessOp: import("../../../../framework/ops.js").Op<import("../../../auth/types/auth-tokens.js").AccessPayload>;
            catalogOp: import("../../../../framework/ops.js").Op<VideoHosting.DacastContent[]>;
            viewsOp: import("../../../../framework/ops.js").Op<import("../../types/video-concepts.js").VideoView[]>;
            privilegesOp: import("../../../../framework/ops.js").Op<import("../../../auth/aspects/users/routines/permissions/types/privilege-display.js").PrivilegeDisplay[]>;
            showsOp: import("../../../../framework/ops.js").Op<import("../../types/video-concepts.js").VideoShow[]>;
        }>;
        subscribe: (listener: (context: import("../../../../toolbox/snapstate/parts/types.js").Readable<{
            accessOp: import("../../../../framework/ops.js").Op<import("../../../auth/types/auth-tokens.js").AccessPayload>;
            catalogOp: import("../../../../framework/ops.js").Op<VideoHosting.DacastContent[]>;
            viewsOp: import("../../../../framework/ops.js").Op<import("../../types/video-concepts.js").VideoView[]>;
            privilegesOp: import("../../../../framework/ops.js").Op<import("../../../auth/aspects/users/routines/permissions/types/privilege-display.js").PrivilegeDisplay[]>;
            showsOp: import("../../../../framework/ops.js").Op<import("../../types/video-concepts.js").VideoShow[]>;
        }>) => void) => () => boolean;
        updateAccessOp(op: import("../../../../framework/ops.js").Op<import("../../../auth/types/auth-tokens.js").AccessPayload>): Promise<void>;
        onVideoHostingUpdate(): Promise<void>;
        initialize: (label: string) => Promise<void>;
        loadModerationData: () => Promise<void>;
        readonly allowance: {
            canModerateVideos: boolean;
            canViewAllVideos: boolean;
        };
        readonly catalog: VideoHosting.DacastContent[];
        readonly views: import("../../types/video-concepts.js").VideoView[];
        readonly privileges: import("../../../auth/aspects/users/routines/permissions/types/privilege-display.js").PrivilegeDisplay[];
        readonly shows: import("../../types/video-concepts.js").VideoShow[];
        getView(label: string): import("../../types/video-concepts.js").VideoView;
        getPrivilege(id: string): import("../../../auth/aspects/users/routines/permissions/types/privilege-display.js").PrivilegeDisplay;
        getShow(label: string): import("../../types/video-concepts.js").VideoShow;
        setView(options: {
            label: string;
            privileges: string[];
            reference: VideoHosting.DacastReference;
        }): Promise<void>;
        deleteView(label: string): Promise<void>;
    };
    init(): Promise<void>;
    render(): import("lit-html").TemplateResult<1>;
}
