var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _XiomeVideoDisplay_instances, _XiomeVideoDisplay_videoControls, _XiomeVideoDisplay_embeds, _XiomeVideoDisplay_renderShow;
import styles from "./xiome-video-display.css.js";
import { videoControls } from "./parts/controls/video-controls.js";
import { renderOp } from "../../../../framework/op-rendering/render-op.js";
import { parseDacastIframeSrc } from "../../dacast/utils/parse-dacast-iframe-src.js";
import { ComponentWithShare, mixinStyles, html, property } from "../../../../framework/component.js";
let XiomeVideoDisplay = class XiomeVideoDisplay extends ComponentWithShare {
    constructor() {
        super(...arguments);
        _XiomeVideoDisplay_instances.add(this);
        this.label = "default";
        _XiomeVideoDisplay_videoControls.set(this, (() => {
            const controls = videoControls({
                contentModel: this.model,
                requestUpdate: () => this.requestUpdate(),
                queryAll: s => Array.from(this.shadowRoot.querySelectorAll(s)),
            });
            this.addSubscription(controls.subscribe);
            return controls;
        })());
        _XiomeVideoDisplay_embeds.set(this, (() => {
            const map = new Map();
            return {
                obtain(details) {
                    if (details.provider !== "dacast")
                        throw new Error(`unsupported video provider "${details.provider}"`);
                    let div = map.get(details.id);
                    if (!div) {
                        div = document.createElement("div");
                        div.setAttribute("data-id", details.id);
                        const iframe = document.createElement("iframe");
                        iframe.src = parseDacastIframeSrc(details.embed);
                        iframe.setAttribute("part", "iframe");
                        div.appendChild(iframe);
                        map.set(details.id, div);
                    }
                    return div;
                },
            };
        })());
    }
    get model() {
        return this.share.contentModel;
    }
    async init() {
        await this.model.initialize(this.label);
    }
    render() {
        return renderOp(this.model.state.accessOp, () => html `
			${this.model.allowance.canModerateVideos
            ? __classPrivateFieldGet(this, _XiomeVideoDisplay_videoControls, "f").render(this.label)
            : null}
			${__classPrivateFieldGet(this, _XiomeVideoDisplay_instances, "m", _XiomeVideoDisplay_renderShow).call(this)}
		`);
    }
};
_XiomeVideoDisplay_videoControls = new WeakMap(), _XiomeVideoDisplay_embeds = new WeakMap(), _XiomeVideoDisplay_instances = new WeakSet(), _XiomeVideoDisplay_renderShow = function _XiomeVideoDisplay_renderShow() {
    const show = this.model.getShow(this.label);
    return show?.details ? html `
			<slot name=title>${show.details.title}</slot>
			${__classPrivateFieldGet(this, _XiomeVideoDisplay_embeds, "f").obtain(show.details) ?? "(embed missing)"}
			<slot></slot>
		` : html `
			<slot name=no-show></slot>
		`;
};
__decorate([
    property({ type: String })
], XiomeVideoDisplay.prototype, "label", void 0);
XiomeVideoDisplay = __decorate([
    mixinStyles(styles)
], XiomeVideoDisplay);
export { XiomeVideoDisplay };
//# sourceMappingURL=xiome-video-display.js.map