import { mockSignToken } from "redcrypto/x/curries/mock-sign-token.js";
import { minute } from "../../../../toolbox/goodtimes/times.js";
async function mockUserMeta({ access, lifespan = minute * 10, }) {
    const signToken = mockSignToken();
    return {
        accessToken: await signToken({
            lifespan,
            payload: access,
        })
    };
}
export async function mockVideoMeta({ userId, origins, privileges }) {
    return mockUserMeta({
        access: {
            appId: "",
            origins,
            permit: { privileges },
            scope: { core: true },
            user: {
                userId,
                profile: {
                    avatar: undefined,
                    nickname: "Steven Seagal",
                    tagline: "totally ripped and sweet",
                },
                roles: [],
                stats: { joined: Date.now() },
            },
        },
    });
}
//# sourceMappingURL=mock-meta.js.map