import { XiomeComponentOptions } from "../../../assembly/frontend/components/types/xiome-component-options.js";
import { XiomeAppManager } from "./apps/components/app-manager/xiome-app-manager.js";
import { XiomeMyAvatar } from "./users/components/my-avatar/xiome-my-avatar.js";
import { XiomeMyAccount } from "./users/components/my-account/xiome-my-account.js";
import { XiomeLoginPanel } from "./users/components/login-panel/xiome-login-panel.js";
import { XiomePrivileges } from "./permissions/components/privileges/xiome-privileges.js";
import { XiomePermissions } from "./permissions/components/permissions/xiome-permissions.js";
export declare function integrateAuthComponents({ models, modals }: XiomeComponentOptions): {
    XiomeMyAvatar: {
        new (...args: any[]): {
            "__#5@#unsubscribes": (() => void)[];
            connectedCallback(): void;
            disconnectedCallback(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & {
        new (...args: any[]): {
            readonly share: {
                accessModel: {
                    getAccessOp(): import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                    getAccess(): import("../types/auth-tokens.js").AccessPayload;
                    getValidAccess(): Promise<import("../types/auth-tokens.js").AccessPayload>;
                    useExistingLogin(): Promise<void>;
                    sendLoginLink(email: string): Promise<void>;
                    login(loginToken: string): Promise<void>;
                    logout(): Promise<void>;
                    reauthorize(): Promise<void>;
                    readable: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                    }>;
                    track: <X>(observer: import("../../../toolbox/snapstate/parts/types.js").Observer<{
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                    }, X>, reaction?: import("../../../toolbox/snapstate/parts/types.js").Reaction<X>) => () => void;
                    subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                    }>) => void) => () => boolean;
                };
            };
            init(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            connectedCallback?(): void;
            disconnectedCallback?(): void;
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & typeof XiomeMyAvatar;
    XiomeLoginPanel: {
        new (...args: any[]): {
            "__#5@#unsubscribes": (() => void)[];
            connectedCallback(): void;
            disconnectedCallback(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & {
        new (...args: any[]): {
            readonly share: {
                accessModel: {
                    getAccessOp(): import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                    getAccess(): import("../types/auth-tokens.js").AccessPayload;
                    getValidAccess(): Promise<import("../types/auth-tokens.js").AccessPayload>;
                    useExistingLogin(): Promise<void>;
                    sendLoginLink(email: string): Promise<void>;
                    login(loginToken: string): Promise<void>;
                    logout(): Promise<void>;
                    reauthorize(): Promise<void>;
                    readable: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                    }>;
                    track: <X>(observer: import("../../../toolbox/snapstate/parts/types.js").Observer<{
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                    }, X>, reaction?: import("../../../toolbox/snapstate/parts/types.js").Reaction<X>) => () => void;
                    subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                    }>) => void) => () => boolean;
                };
            };
            init(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            connectedCallback?(): void;
            disconnectedCallback?(): void;
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & typeof XiomeLoginPanel;
    XiomeAppManager: {
        new (...args: any[]): {
            "__#5@#unsubscribes": (() => void)[];
            connectedCallback(): void;
            disconnectedCallback(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & {
        new (...args: any[]): {
            readonly share: {
                modals: import("../../../assembly/frontend/modal/types/modal-system.js").ModalSystem;
                appsModel: {
                    state: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        active: boolean;
                        appRecords: import("../../../framework/ops.js").Op<import("./apps/models/types/app-records.js").AppRecords>;
                        addingNewApp: import("../../../framework/ops.js").Op<null>;
                    }>;
                    subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        active: boolean;
                        appRecords: import("../../../framework/ops.js").Op<import("./apps/models/types/app-records.js").AppRecords>;
                        addingNewApp: import("../../../framework/ops.js").Op<null>;
                    }>) => void) => () => boolean;
                    appEditService: import("renraku/x/types/remote/remote").Remote<import("renraku/x/types/api/api-context").ApiContext<import("../types/auth-metas.js").AppOwnerMeta, import("../types/auth-metas.js").AppOwnerAuth, {
                        updateApp({ appTables, authorizeAppOwner }: import("../types/auth-metas.js").AppOwnerAuth, { appId: appIdString, appDraft }: {
                            appId: string;
                            appDraft: import("./apps/types/app-draft.js").AppDraft;
                        }): Promise<void>;
                        deleteApp({ appTables, authorizeAppOwner }: import("../types/auth-metas.js").AppOwnerAuth, { appId: appIdString }: {
                            appId: string;
                        }): Promise<void>;
                        listAdmins({ authorizeAppOwner }: import("../types/auth-metas.js").AppOwnerAuth, { appId: appIdString }: {
                            appId: string;
                        }): Promise<import("./apps/types/admin-email-display.js").AdminEmailDisplay[]>;
                        assignPlatformUserAsAdmin({ authTablesForPlatform, authorizeAppOwner }: import("../types/auth-metas.js").AppOwnerAuth, { appId: appIdString, platformUserId: platformUserIdString }: {
                            appId: string;
                            platformUserId: string;
                        }): Promise<void>;
                        assignAdmin({ authorizeAppOwner }: import("../types/auth-metas.js").AppOwnerAuth, { appId: appIdString, email }: {
                            appId: string;
                            email: string;
                        }): Promise<void>;
                        revokeAdmin({ authorizeAppOwner }: import("../types/auth-metas.js").AppOwnerAuth, { appId: appIdString, userId: userIdString }: {
                            appId: string;
                            userId: string;
                        }): Promise<void>;
                    }, import("renraku/x/types/primitives/policy").Policy<import("../types/auth-metas.js").AppOwnerMeta, import("../types/auth-metas.js").AppOwnerAuth, import("renraku/x/types/http/http-request").HttpRequest>>>;
                    getApp(appId: string): import("./apps/types/app-display.js").AppDisplay;
                    loadApps: () => Promise<import("./apps/types/app-display.js").AppDisplay[]>;
                    deleteApp: (appId: string) => Promise<void>;
                    updateApp: (appId: string, appDraft: import("./apps/types/app-draft.js").AppDraft) => Promise<void>;
                    registerApp: (appDraft: import("./apps/types/app-draft.js").AppDraft) => Promise<import("./apps/types/app-display.js").AppDisplay>;
                    updateAccessOp(op: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>): Promise<void>;
                };
            };
            init(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            connectedCallback?(): void;
            disconnectedCallback?(): void;
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & typeof XiomeAppManager;
    XiomeMyAccount: {
        new (...args: any[]): {
            "__#5@#unsubscribes": (() => void)[];
            connectedCallback(): void;
            disconnectedCallback(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & {
        new (...args: any[]): {
            readonly share: {
                personalModel: {
                    track: <X_1>(observer: import("../../../toolbox/snapstate/parts/types.js").Observer<{
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                        submitDraftOp: import("../../../framework/ops.js").Op<void>;
                    }, X_1>, reaction?: import("../../../toolbox/snapstate/parts/types.js").Reaction<X_1>) => () => void;
                    subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                        submitDraftOp: import("../../../framework/ops.js").Op<void>;
                    }>) => void) => () => boolean;
                    readable: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                        submitDraftOp: import("../../../framework/ops.js").Op<void>;
                    }>;
                    saveProfile(profileDraft: import("./users/routines/personal/types/profile-draft.js").ProfileDraft): Promise<void>;
                    updateAccessOp(op: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>): void;
                };
            };
            init(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            connectedCallback?(): void;
            disconnectedCallback?(): void;
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & typeof XiomeMyAccount;
    XiomePermissions: {
        new (...args: any[]): {
            "__#5@#unsubscribes": (() => void)[];
            connectedCallback(): void;
            disconnectedCallback(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & {
        new (...args: any[]): {
            readonly share: {
                modals: import("../../../assembly/frontend/modal/types/modal-system.js").ModalSystem;
                permissionsModel: {
                    readable: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        active: boolean;
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                        permissionsDisplay: import("../../../framework/ops.js").Op<import("./users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                    }>;
                    subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        active: boolean;
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                        permissionsDisplay: import("../../../framework/ops.js").Op<import("./users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                    }>) => void) => () => boolean;
                    track: <X_2>(observer: import("../../../toolbox/snapstate/parts/types.js").Observer<{
                        active: boolean;
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                        permissionsDisplay: import("../../../framework/ops.js").Op<import("./users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                    }, X_2>, reaction?: import("../../../toolbox/snapstate/parts/types.js").Reaction<X_2>) => () => void;
                    getAccess: () => import("../types/auth-tokens.js").AccessPayload;
                    initialize: () => Promise<void>;
                    getUserCanCustomizePermissions: () => boolean;
                    createRole: (args_0: {
                        label: string;
                    }) => Promise<void>;
                    deleteRole: (args_0: {
                        roleId: string;
                    }) => Promise<void>;
                    assignPrivilege: (args_0: {
                        roleId: string;
                        privilegeId: string;
                    }) => Promise<void>;
                    unassignPrivilege: (args_0: {
                        roleId: string;
                        privilegeId: string;
                    }) => Promise<void>;
                    deletePrivilege: (args_0: {
                        privilegeId: string;
                    }) => Promise<void>;
                    createPrivilege: (args_0: {
                        label: string;
                    }) => Promise<import("./users/routines/permissions/types/privilege-display.js").PrivilegeDisplay>;
                    updateAccessOp(op: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>): Promise<void>;
                };
            };
            init(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            connectedCallback?(): void;
            disconnectedCallback?(): void;
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & typeof XiomePermissions;
    XiomePrivileges: {
        new (...args: any[]): {
            "__#5@#unsubscribes": (() => void)[];
            connectedCallback(): void;
            disconnectedCallback(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & {
        new (...args: any[]): {
            readonly share: {
                modals: import("../../../assembly/frontend/modal/types/modal-system.js").ModalSystem;
                permissionsModel: {
                    readable: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        active: boolean;
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                        permissionsDisplay: import("../../../framework/ops.js").Op<import("./users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                    }>;
                    subscribe: (listener: (context: import("../../../toolbox/snapstate/parts/types.js").Readable<{
                        active: boolean;
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                        permissionsDisplay: import("../../../framework/ops.js").Op<import("./users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                    }>) => void) => () => boolean;
                    track: <X_2>(observer: import("../../../toolbox/snapstate/parts/types.js").Observer<{
                        active: boolean;
                        accessOp: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>;
                        permissionsDisplay: import("../../../framework/ops.js").Op<import("./users/routines/permissions/types/permissions-display.js").PermissionsDisplay>;
                    }, X_2>, reaction?: import("../../../toolbox/snapstate/parts/types.js").Reaction<X_2>) => () => void;
                    getAccess: () => import("../types/auth-tokens.js").AccessPayload;
                    initialize: () => Promise<void>;
                    getUserCanCustomizePermissions: () => boolean;
                    createRole: (args_0: {
                        label: string;
                    }) => Promise<void>;
                    deleteRole: (args_0: {
                        roleId: string;
                    }) => Promise<void>;
                    assignPrivilege: (args_0: {
                        roleId: string;
                        privilegeId: string;
                    }) => Promise<void>;
                    unassignPrivilege: (args_0: {
                        roleId: string;
                        privilegeId: string;
                    }) => Promise<void>;
                    deletePrivilege: (args_0: {
                        privilegeId: string;
                    }) => Promise<void>;
                    createPrivilege: (args_0: {
                        label: string;
                    }) => Promise<import("./users/routines/permissions/types/privilege-display.js").PrivilegeDisplay>;
                    updateAccessOp(op: import("../../../framework/ops.js").Op<import("../types/auth-tokens.js").AccessPayload>): Promise<void>;
                };
            };
            init(): void;
            render?(): unknown;
            firstUpdated?(_changedProperties: Map<string | number | symbol, unknown>): void;
            requestUpdate: (name?: PropertyKey, oldValue?: unknown, options?: import("@lit/reactive-element").PropertyDeclaration<unknown, unknown>) => void;
            observedAttributes?: string[];
            connectedCallback?(): void;
            disconnectedCallback?(): void;
            attributeChangedCallback?(attributeName: string, oldValue: string, newValue: string): void;
            accessKey: string;
            readonly accessKeyLabel: string;
            autocapitalize: string;
            dir: string;
            draggable: boolean;
            hidden: boolean;
            innerText: string;
            lang: string;
            readonly offsetHeight: number;
            readonly offsetLeft: number;
            readonly offsetParent: Element;
            readonly offsetTop: number;
            readonly offsetWidth: number;
            outerText: string;
            spellcheck: boolean;
            title: string;
            translate: boolean;
            click(): void;
            addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: HTMLElement, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): void;
            addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
            removeEventListener<K_1 extends keyof HTMLElementEventMap>(type: K_1, listener: (this: HTMLElement, ev: HTMLElementEventMap[K_1]) => any, options?: boolean | EventListenerOptions): void;
            removeEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | EventListenerOptions): void;
            readonly attributes: NamedNodeMap;
            readonly classList: DOMTokenList;
            className: string;
            readonly clientHeight: number;
            readonly clientLeft: number;
            readonly clientTop: number;
            readonly clientWidth: number;
            id: string;
            readonly localName: string;
            readonly namespaceURI: string;
            onfullscreenchange: (this: Element, ev: Event) => any;
            onfullscreenerror: (this: Element, ev: Event) => any;
            outerHTML: string;
            readonly ownerDocument: Document;
            readonly part: DOMTokenList;
            readonly prefix: string;
            readonly scrollHeight: number;
            scrollLeft: number;
            scrollTop: number;
            readonly scrollWidth: number;
            readonly shadowRoot: ShadowRoot;
            slot: string;
            readonly tagName: string;
            attachShadow(init: ShadowRootInit): ShadowRoot;
            closest<K_2 extends keyof HTMLElementTagNameMap>(selector: K_2): HTMLElementTagNameMap[K_2];
            closest<K_3 extends keyof SVGElementTagNameMap>(selector: K_3): SVGElementTagNameMap[K_3];
            closest<E extends Element = Element>(selectors: string): E;
            getAttribute(qualifiedName: string): string;
            getAttributeNS(namespace: string, localName: string): string;
            getAttributeNames(): string[];
            getAttributeNode(qualifiedName: string): Attr;
            getAttributeNodeNS(namespace: string, localName: string): Attr;
            getBoundingClientRect(): DOMRect;
            getClientRects(): DOMRectList;
            getElementsByClassName(classNames: string): HTMLCollectionOf<Element>;
            getElementsByTagName<K_4 extends keyof HTMLElementTagNameMap>(qualifiedName: K_4): HTMLCollectionOf<HTMLElementTagNameMap[K_4]>;
            getElementsByTagName<K_5 extends keyof SVGElementTagNameMap>(qualifiedName: K_5): HTMLCollectionOf<SVGElementTagNameMap[K_5]>;
            getElementsByTagName(qualifiedName: string): HTMLCollectionOf<Element>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/1999/xhtml", localName: string): HTMLCollectionOf<HTMLElement>;
            getElementsByTagNameNS(namespaceURI: "http://www.w3.org/2000/svg", localName: string): HTMLCollectionOf<SVGElement>;
            getElementsByTagNameNS(namespace: string, localName: string): HTMLCollectionOf<Element>;
            hasAttribute(qualifiedName: string): boolean;
            hasAttributeNS(namespace: string, localName: string): boolean;
            hasAttributes(): boolean;
            hasPointerCapture(pointerId: number): boolean;
            insertAdjacentElement(where: InsertPosition, element: Element): Element;
            insertAdjacentHTML(position: InsertPosition, text: string): void;
            insertAdjacentText(where: InsertPosition, data: string): void;
            matches(selectors: string): boolean;
            releasePointerCapture(pointerId: number): void;
            removeAttribute(qualifiedName: string): void;
            removeAttributeNS(namespace: string, localName: string): void;
            removeAttributeNode(attr: Attr): Attr;
            requestFullscreen(options?: FullscreenOptions): Promise<void>;
            requestPointerLock(): void;
            scroll(options?: ScrollToOptions): void;
            scroll(x: number, y: number): void;
            scrollBy(options?: ScrollToOptions): void;
            scrollBy(x: number, y: number): void;
            scrollIntoView(arg?: boolean | ScrollIntoViewOptions): void;
            scrollTo(options?: ScrollToOptions): void;
            scrollTo(x: number, y: number): void;
            setAttribute(qualifiedName: string, value: string): void;
            setAttributeNS(namespace: string, qualifiedName: string, value: string): void;
            setAttributeNode(attr: Attr): Attr;
            setAttributeNodeNS(attr: Attr): Attr;
            setPointerCapture(pointerId: number): void;
            toggleAttribute(qualifiedName: string, force?: boolean): boolean;
            webkitMatchesSelector(selectors: string): boolean;
            readonly baseURI: string;
            readonly childNodes: NodeListOf<ChildNode>;
            readonly firstChild: ChildNode;
            readonly isConnected: boolean;
            readonly lastChild: ChildNode;
            readonly nextSibling: ChildNode;
            readonly nodeName: string;
            readonly nodeType: number;
            nodeValue: string;
            readonly parentElement: HTMLElement;
            readonly parentNode: ParentNode;
            readonly previousSibling: ChildNode;
            textContent: string;
            appendChild<T extends Node>(node: T): T;
            cloneNode(deep?: boolean): Node;
            compareDocumentPosition(other: Node): number;
            contains(other: Node): boolean;
            getRootNode(options?: GetRootNodeOptions): Node;
            hasChildNodes(): boolean;
            insertBefore<T_1 extends Node>(node: T_1, child: Node): T_1;
            isDefaultNamespace(namespace: string): boolean;
            isEqualNode(otherNode: Node): boolean;
            isSameNode(otherNode: Node): boolean;
            lookupNamespaceURI(prefix: string): string;
            lookupPrefix(namespace: string): string;
            normalize(): void;
            removeChild<T_2 extends Node>(child: T_2): T_2;
            replaceChild<T_3 extends Node>(node: Node, child: T_3): T_3;
            readonly ATTRIBUTE_NODE: number;
            readonly CDATA_SECTION_NODE: number;
            readonly COMMENT_NODE: number;
            readonly DOCUMENT_FRAGMENT_NODE: number;
            readonly DOCUMENT_NODE: number;
            readonly DOCUMENT_POSITION_CONTAINED_BY: number;
            readonly DOCUMENT_POSITION_CONTAINS: number;
            readonly DOCUMENT_POSITION_DISCONNECTED: number;
            readonly DOCUMENT_POSITION_FOLLOWING: number;
            readonly DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC: number;
            readonly DOCUMENT_POSITION_PRECEDING: number;
            readonly DOCUMENT_TYPE_NODE: number;
            readonly ELEMENT_NODE: number;
            readonly ENTITY_NODE: number;
            readonly ENTITY_REFERENCE_NODE: number;
            readonly NOTATION_NODE: number;
            readonly PROCESSING_INSTRUCTION_NODE: number;
            readonly TEXT_NODE: number;
            dispatchEvent(event: Event): boolean;
            ariaAtomic: string;
            ariaAutoComplete: string;
            ariaBusy: string;
            ariaChecked: string;
            ariaColCount: string;
            ariaColIndex: string;
            ariaColSpan: string;
            ariaCurrent: string;
            ariaDisabled: string;
            ariaExpanded: string;
            ariaHasPopup: string;
            ariaHidden: string;
            ariaKeyShortcuts: string;
            ariaLabel: string;
            ariaLevel: string;
            ariaLive: string;
            ariaModal: string;
            ariaMultiLine: string;
            ariaMultiSelectable: string;
            ariaOrientation: string;
            ariaPlaceholder: string;
            ariaPosInSet: string;
            ariaPressed: string;
            ariaReadOnly: string;
            ariaRequired: string;
            ariaRoleDescription: string;
            ariaRowCount: string;
            ariaRowIndex: string;
            ariaRowSpan: string;
            ariaSelected: string;
            ariaSetSize: string;
            ariaSort: string;
            ariaValueMax: string;
            ariaValueMin: string;
            ariaValueNow: string;
            ariaValueText: string;
            animate(keyframes: PropertyIndexedKeyframes | Keyframe[], options?: number | KeyframeAnimationOptions): Animation;
            getAnimations(options?: GetAnimationsOptions): Animation[];
            after(...nodes: (string | Node)[]): void;
            before(...nodes: (string | Node)[]): void;
            remove(): void;
            replaceWith(...nodes: (string | Node)[]): void;
            innerHTML: string;
            readonly nextElementSibling: Element;
            readonly previousElementSibling: Element;
            readonly childElementCount: number;
            readonly children: HTMLCollection;
            readonly firstElementChild: Element;
            readonly lastElementChild: Element;
            append(...nodes: (string | Node)[]): void;
            prepend(...nodes: (string | Node)[]): void;
            querySelector<K_6 extends keyof HTMLElementTagNameMap>(selectors: K_6): HTMLElementTagNameMap[K_6];
            querySelector<K_7 extends keyof SVGElementTagNameMap>(selectors: K_7): SVGElementTagNameMap[K_7];
            querySelector<E_1 extends Element = Element>(selectors: string): E_1;
            querySelectorAll<K_8 extends keyof HTMLElementTagNameMap>(selectors: K_8): NodeListOf<HTMLElementTagNameMap[K_8]>;
            querySelectorAll<K_9 extends keyof SVGElementTagNameMap>(selectors: K_9): NodeListOf<SVGElementTagNameMap[K_9]>;
            querySelectorAll<E_2 extends Element = Element>(selectors: string): NodeListOf<E_2>;
            replaceChildren(...nodes: (string | Node)[]): void;
            readonly assignedSlot: HTMLSlotElement;
            oncopy: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            oncut: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            onpaste: (this: DocumentAndElementEventHandlers, ev: ClipboardEvent) => any;
            readonly style: CSSStyleDeclaration;
            contentEditable: string;
            enterKeyHint: string;
            inputMode: string;
            readonly isContentEditable: boolean;
            onabort: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onanimationcancel: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationend: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationiteration: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onanimationstart: (this: GlobalEventHandlers, ev: AnimationEvent) => any;
            onauxclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onblur: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            oncanplay: (this: GlobalEventHandlers, ev: Event) => any;
            oncanplaythrough: (this: GlobalEventHandlers, ev: Event) => any;
            onchange: (this: GlobalEventHandlers, ev: Event) => any;
            onclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onclose: (this: GlobalEventHandlers, ev: Event) => any;
            oncontextmenu: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            oncuechange: (this: GlobalEventHandlers, ev: Event) => any;
            ondblclick: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            ondrag: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragend: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragenter: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragleave: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragover: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondragstart: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondrop: (this: GlobalEventHandlers, ev: DragEvent) => any;
            ondurationchange: (this: GlobalEventHandlers, ev: Event) => any;
            onemptied: (this: GlobalEventHandlers, ev: Event) => any;
            onended: (this: GlobalEventHandlers, ev: Event) => any;
            onerror: OnErrorEventHandlerNonNull;
            onfocus: (this: GlobalEventHandlers, ev: FocusEvent) => any;
            onformdata: (this: GlobalEventHandlers, ev: FormDataEvent) => any;
            ongotpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            oninput: (this: GlobalEventHandlers, ev: Event) => any;
            oninvalid: (this: GlobalEventHandlers, ev: Event) => any;
            onkeydown: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeypress: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onkeyup: (this: GlobalEventHandlers, ev: KeyboardEvent) => any;
            onload: (this: GlobalEventHandlers, ev: Event) => any;
            onloadeddata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadedmetadata: (this: GlobalEventHandlers, ev: Event) => any;
            onloadstart: (this: GlobalEventHandlers, ev: Event) => any;
            onlostpointercapture: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onmousedown: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseenter: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseleave: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmousemove: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseout: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseover: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onmouseup: (this: GlobalEventHandlers, ev: MouseEvent) => any;
            onpause: (this: GlobalEventHandlers, ev: Event) => any;
            onplay: (this: GlobalEventHandlers, ev: Event) => any;
            onplaying: (this: GlobalEventHandlers, ev: Event) => any;
            onpointercancel: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerdown: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerenter: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerleave: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointermove: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerout: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerover: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onpointerup: (this: GlobalEventHandlers, ev: PointerEvent) => any;
            onprogress: (this: GlobalEventHandlers, ev: ProgressEvent<EventTarget>) => any;
            onratechange: (this: GlobalEventHandlers, ev: Event) => any;
            onreset: (this: GlobalEventHandlers, ev: Event) => any;
            onresize: (this: GlobalEventHandlers, ev: UIEvent) => any;
            onscroll: (this: GlobalEventHandlers, ev: Event) => any;
            onseeked: (this: GlobalEventHandlers, ev: Event) => any;
            onseeking: (this: GlobalEventHandlers, ev: Event) => any;
            onselect: (this: GlobalEventHandlers, ev: Event) => any;
            onselectionchange: (this: GlobalEventHandlers, ev: Event) => any;
            onselectstart: (this: GlobalEventHandlers, ev: Event) => any;
            onstalled: (this: GlobalEventHandlers, ev: Event) => any;
            onsubmit: (this: GlobalEventHandlers, ev: Event) => any;
            onsuspend: (this: GlobalEventHandlers, ev: Event) => any;
            ontimeupdate: (this: GlobalEventHandlers, ev: Event) => any;
            ontoggle: (this: GlobalEventHandlers, ev: Event) => any;
            ontouchcancel?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchend?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchmove?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontouchstart?: (this: GlobalEventHandlers, ev: TouchEvent) => any;
            ontransitioncancel: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionend: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionrun: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            ontransitionstart: (this: GlobalEventHandlers, ev: TransitionEvent) => any;
            onvolumechange: (this: GlobalEventHandlers, ev: Event) => any;
            onwaiting: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationend: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationiteration: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkitanimationstart: (this: GlobalEventHandlers, ev: Event) => any;
            onwebkittransitionend: (this: GlobalEventHandlers, ev: Event) => any;
            onwheel: (this: GlobalEventHandlers, ev: WheelEvent) => any;
            readonly dataset: DOMStringMap;
            nonce?: string;
            tabIndex: number;
            blur(): void;
            focus(options?: FocusOptions): void;
        };
    } & typeof XiomePrivileges;
};
